import java.awt.*;
import java.awt.event.KeyEvent;
import java.awt.event.MouseEvent;
import java.awt.geom.*;
import java.util.ArrayList;
import java.io.Serializable;

import javax.swing.*;

public class Canvas_State_Rect extends Canvas_State{	  
	private static final int MIN_W = 20;
	private static final int MIN_H = 20;
		
	Canvas_State_Rect(MyCanvas _canvas, Model_Root _data, Model_State s, int _mode){
		super(_canvas, _data, s, _mode);
	}
	
	public Point get_connect_trans_point(Point p){
		Point p2 = new Point(p.x - pos().x, p.y -pos().y);
		Point new_p = new Point();
				
		int dtop = Math.abs(-h() / 2 - p2.y);
		int dbottom = Math.abs(h() / 2 - p2.y);
		int dleft = Math.abs(-w() / 2 - p2.x);
		int dright = Math.abs(w() / 2 - p2.x);
		
		//上辺
		if(dtop <= dbottom && dtop <= dleft && dtop <= dright){
			new_p.x = p.x;
			new_p.y = pos().y - h() / 2;
		}
		//下辺
		else if(dbottom <= dtop && dbottom <= dleft && dbottom <= dright){
			new_p.x = p.x;
			new_p.y = pos().y + h() / 2;
		}
		//右辺
		else if(dright <= dbottom && dright <= dleft && dright <= dtop){
			new_p.x = pos().x + w() / 2;
			new_p.y = p.y;
		}
		//左辺
		else{
			new_p.x = pos().x - w() / 2;
			new_p.y = p.y;
		}
				
		return new_p;
	}
	
	public boolean is_in(Rectangle r){
		if(r.x <= pos().x - w() / 2 && pos().x + w() / 2 <= r.x + r.width && r.y <= pos().y - h() / 2 && pos().y + h() / 2 <= r.y + r.height) return true;
		else return false;
	}
		
	public boolean isHit(Point p){
		if(p.x >= pos().x - w() / 2 - HIT_MARGIN_SIZE && pos().x + w() / 2 + HIT_MARGIN_SIZE > p.x && p.y >= pos().y - h() / 2 - HIT_MARGIN_SIZE && pos().y + h() / 2 + HIT_MARGIN_SIZE > p.y){
			return true;
		}
		
		if(mode == MODE_FOCUSED){
			if(getHitPoint(p) != NONE) return true;
		}
		return false;
	}
	
	public Point max_point(){
		return new Point(pos().x + w() / 2, pos().y + h() / 2);
	}

    public void mousePressed(MouseEvent e, boolean is_multi_focused){
    	mouse_last_pos = e.getPoint();
    	setMode(MODE_FOCUSED);
    	
    	is_draged = false;
    	if(is_multi_focused == true) focused_point = NONE;
    	else{
    		focused_point = getHitPoint(e.getPoint());
    		
    		switch(focused_point){
			case POINT_LEFT_TOP:
				mouse_point_offset_x = e.getX() - (pos().x - w() / 2);
	    		mouse_point_offset_y = e.getY() - (pos().y - h() / 2);
				break;
			case POINT_LEFT_BOTTOM:
				mouse_point_offset_x = e.getX() - (pos().x - w() / 2);
	    		mouse_point_offset_y = e.getY() - (pos().y + h() / 2);
				break;
			case POINT_RIGHT_TOP:
				mouse_point_offset_x = e.getX() - (pos().x + w() / 2);
	    		mouse_point_offset_y = e.getY() - (pos().y - h() / 2);
				break;
			case POINT_RIGHT_BOTTOM:
				mouse_point_offset_x = e.getX() - (pos().x + w() / 2);
	    		mouse_point_offset_y = e.getY() - (pos().y + h() / 2);
				break;
			}
    	}
    	
    	set_cursor(e, is_multi_focused);
    }
	
	public void mouseDragged(MouseEvent e, boolean is_multi_focused){
		if(focused_point == NONE){
			canvas.request_set_cursor(Cursor.CROSSHAIR_CURSOR);
			if(is_multi_focused == true){
				move_pos_without_focused_trans(e.getPoint().x - mouse_last_pos.x, e.getPoint().y - mouse_last_pos.y);
			}
			else{
				move_pos_with_trans(e.getPoint().x - mouse_last_pos.x, e.getPoint().y - mouse_last_pos.y);
			}
		}
		else{
			int w = MIN_W;
			int h = MIN_H;
			switch(focused_point){
			case POINT_LEFT_TOP:
				canvas.request_set_cursor(Cursor.NW_RESIZE_CURSOR);
				w = Math.max((pos().x - (e.getX() - mouse_point_offset_x)) * 2, min_w());
				h = Math.max((pos().y - (e.getY() - mouse_point_offset_y)) * 2, min_h());
				break;
			case POINT_LEFT_BOTTOM:
				canvas.request_set_cursor(Cursor.SW_RESIZE_CURSOR);
				w = Math.max((pos().x - (e.getX() - mouse_point_offset_x)) * 2, min_w());
				h = Math.max(((e.getY() - mouse_point_offset_y) - pos().y) * 2, min_h());
				break;
			case POINT_RIGHT_TOP:
				canvas.request_set_cursor(Cursor.NE_RESIZE_CURSOR);
				w = Math.max(((e.getX() - mouse_point_offset_x) - pos().x) * 2, min_w());
				h = Math.max((pos().y - (e.getY() - mouse_point_offset_y)) * 2, min_h());
				break;
			case POINT_RIGHT_BOTTOM:
				canvas.request_set_cursor(Cursor.SE_RESIZE_CURSOR);
				w = Math.max(((e.getX() - mouse_point_offset_x) - pos().x) * 2, min_w());
				h = Math.max(((e.getY() - mouse_point_offset_y) - pos().y) * 2, min_h());
				break;
			}
			
			data.set_state_wh(model, w, h);
		}
		
		mouse_last_pos = e.getPoint();
		click_num = 0;
		is_draged = true;
	}	
	
	/******* private *******/		
	private int h(){
		return model.get_h();
	}
	
	private int w(){
		return model.get_w();
	}
			
	protected int min_w(){
		return scaled(MIN_W);
	}
	
	protected int min_h(){
		return scaled(MIN_H);
	}
	
	protected void paint_local(Graphics g, Color bg_c, Color edge_c, Color label_c, boolean is_rect, boolean is_transparent){
		Graphics2D g2 = (Graphics2D)g;
		g2.setRenderingHint(RenderingHints.KEY_ANTIALIASING, RenderingHints.VALUE_ANTIALIAS_ON);
		
		float alpha = 1.0f;
		if(is_transparent) alpha = 0.5f;
		g2.setComposite(AlphaComposite.getInstance(AlphaComposite.SRC_OVER, alpha));
		
		g2.setColor(bg_c);
		g2.fillRect(pos().x - w() / 2, pos().y - h() / 2, w(), h());
		
		Graphics2D g3 = (Graphics2D)g2;
		BasicStroke stroke;
		g3.setColor(edge_c);
		stroke = new BasicStroke(scaled_f(2.0f)); //線の太さを変更
		g3.setStroke(stroke); //線の種類を設定
		g3.drawRect(pos().x - w() / 2, pos().y - h() / 2, w(), h());
		
		g3.setComposite(AlphaComposite.getInstance(AlphaComposite.SRC_OVER, 1.0f));
		
		if(is_rect){
			//枠線
			Graphics2D g4 = (Graphics2D)g2;
			BasicStroke stroke2;
			g4.setColor(FOCUS_RECT_COLOR);
			stroke2 = new BasicStroke(scaled_f(2.0f),		// 太さ
                    BasicStroke.CAP_BUTT,		// 端は残す
                    BasicStroke.JOIN_MITER,		// 継ぎ目は斜め
                    1.0f,						// 継ぎ目の限界
                    new float[] {scaled_f(5.0f), scaled_f(5.0f)},	// 5書いて5書かないダッシュ
                    scaled_f(0.0f));						// ダッシュの開始フェーズ
			g4.setStroke(stroke2); //線の種類を設定
			g4.drawRect(pos().x - w() / 2, pos().y - h() / 2, w(), h());	
			
			//コントロールポイント
			g4.setStroke(new BasicStroke(scaled_f(2.0f)));
			
			update_point_list();
			for (int i = 0; i < point_list.size(); i ++){
				Point p = point_list.get(i);
					
				g4.setColor(POINT_COLOR);
				g4.fillOval(p.x - point_size(), p.y - point_size(), point_size() * 2, point_size() * 2);
				
				g4.setColor(POINT_EDGE_COLOR);
				g4.drawOval(p.x - point_size(), p.y - point_size(), point_size() * 2, point_size() * 2);
			}
		}
		
		if(label().length() > 0){
			Font font = new Font(canvas.get_font_name(), g.getFont().getStyle(), scaled(canvas.get_org_font_size()));
			g.setFont(font);
			
			int text_w = canvas.multiline_string_width(g, label());
			int text_h = canvas.multiline_string_height(g, label());
			g.setColor(label_c);
	        canvas.draw_multiline_string(g, new Point(pos().x - text_w / 2, pos().y - text_h / 2), label(), true);
		}
	}
			
	protected void update_point_list(){
		if(point_list == null){
			point_list = new ArrayList<Point>();
			point_list.add(new Point());
			point_list.add(new Point());
			point_list.add(new Point());
			point_list.add(new Point());			
		}
		
		point_list.get(0).setLocation(pos().x - w() / 2, pos().y - h() / 2);
		point_list.get(1).setLocation(pos().x - w() / 2, pos().y + h() / 2);
		point_list.get(2).setLocation(pos().x + w() / 2, pos().y - h() / 2);
		point_list.get(3).setLocation(pos().x + w() / 2, pos().y + h() / 2);
	}
}
