import java.awt.datatransfer.*;
import java.io.IOException;
import java.util.ArrayList;



class ClipBoard_Data implements Transferable {
	String xml = "";
	
	static public DataFlavor ASMFlavor;
	private DataFlavor flavors[] = {ASMFlavor};

	static {
		try {
			ASMFlavor = new DataFlavor(Class.forName("java.lang.String") , "AlloyStateModel_Obj");
		}
		catch(Exception e) {}
	}
	public ClipBoard_Data(ArrayList<Canvas_State> state_list, ArrayList<Canvas_Trans> trans_list, ArrayList<Canvas_Memo> memo_list, ArrayList<Model_Event> event_model_list) {
		xml = get_xml(state_list, trans_list, memo_list, event_model_list);
	}

	public boolean isDataFlavorSupported(DataFlavor flavor) {
		return flavor.equals(ASMFlavor);
	}
	
	public synchronized DataFlavor[] getTransferDataFlavors() {
		return flavors;
	}
	
	public synchronized Object getTransferData(DataFlavor flavor) throws UnsupportedFlavorException , IOException {
		if(flavor.equals(ASMFlavor)){
			return xml;
		}
		else{
			throw new UnsupportedFlavorException(flavor);
		}
	}
	
	private String get_xml(ArrayList<Canvas_State> state_list, ArrayList<Canvas_Trans> trans_list, ArrayList<Canvas_Memo> memo_list, ArrayList<Model_Event> event_model_list){
		String text = "";
		
		text += "<?xml version=\"1.0\" encoding=\"Shift-JIS\"?>\n";
		
		text += "<Alloy_State_Model>\n";
		
		text += "\t<State_List>\n";
		ArrayList<Model_State> state_model_list = new ArrayList<Model_State>();
		for(int i = 0; i < state_list.size(); i ++){
			text += state_list.get(i).get_model().get_xml();
			state_model_list.add(state_list.get(i).get_model());
		}
		text += "\t</State_List>\n";
			
		text += "\t<Trans_List>\n";
		for(int i = 0; i < trans_list.size(); i ++){
			text += trans_list.get(i).get_model().get_xml(state_model_list);
		}
		text += "\t</Trans_List>\n";
		
		text += "\t<Memo_List>\n";
		for(int i = 0; i < memo_list.size(); i ++){
			text += memo_list.get(i).get_model().get_xml();
		}
		text += "\t</Memo_List>\n";
		
		text += "</Alloy_State_Model>\n";
		
		return text;
	}
}