import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Component;
import java.awt.FlowLayout;
import java.awt.Font;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.BoxLayout;
import javax.swing.DefaultListModel;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JSplitPane;
import javax.swing.JTextArea;
import javax.swing.JTextField;
import javax.swing.border.LineBorder;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;
import javax.swing.undo.UndoManager;


abstract public class Dialog_2Pain extends Dialog_Base implements ActionListener, ListSelectionListener {
	protected JSplitPane split_pane = null;
	protected JPanel panel_left = null;
	protected JPanel panel_right = null;
	protected JPanel panel_bottom = null;
	protected JPanel panel_left_list = null;
	protected JPanel panel_left_button = null;
	
	protected JPanel event_button_panel = null;
	
	protected JButton b_add = null;
	protected JButton b_del = null;
	protected JButton b_dup = null;
	protected JButton b_close = null;
	
	protected JList list_left;
	protected DefaultListModel list_left_model;
	
	Dialog_2Pain(MyFrame _frame, Model_Root _model_root, String _title){
		super(_frame, _model_root, _title);
	}

	@Override
	protected void create_view() {
		this.setLayout(new BorderLayout(3, 3));
		this.setBackground(Color.WHITE);
		
		//分割領域
		split_pane = new JSplitPane();
		split_pane.setDividerLocation(250);
		split_pane.setOneTouchExpandable(false);
		getContentPane().add(split_pane, BorderLayout.CENTER);
		{
			//左パネル
			panel_left = new JPanel();
			panel_left.setLayout(new BorderLayout(3, 3));
			split_pane.setLeftComponent(panel_left);
			{
				//リストパネル
				panel_left_list = new JPanel();
				panel_left_list.setLayout(new BorderLayout());
				panel_left_list.setBackground(Color.WHITE);
				JScrollPane scroll_pane = new JScrollPane();
				scroll_pane.getVerticalScrollBar().setUnitIncrement(15);
				scroll_pane.setViewportView(panel_left_list);
				panel_left.add(scroll_pane, BorderLayout.CENTER);
				{
					list_left_model = new DefaultListModel();
					list_left = new JList(list_left_model);
					list_left.setBackground(Color.WHITE);
					list_left.addListSelectionListener(this);
				    panel_left_list.add(list_left, BorderLayout.WEST);
				}
				
				//ボタンパネル
				event_button_panel = new JPanel();
				event_button_panel.setLayout(new FlowLayout(FlowLayout.RIGHT));
				panel_left.add(event_button_panel, BorderLayout.SOUTH);
				{
					b_del = new JButton("削除");
					b_del.addActionListener(this);
					event_button_panel.add(b_del);
					
					b_add = new JButton("追加");
					b_add.addActionListener(this);
					event_button_panel.add(b_add);
					
					b_dup = new JButton("複製");
					b_dup.addActionListener(this);
					event_button_panel.add(b_dup);
				}
			}
			
			//右パネル
			panel_right = new JPanel();
			panel_right.setLayout(new BorderLayout(3, 3));
			split_pane.setRightComponent(panel_right);
		}
		
		//下パネル
		panel_bottom = new JPanel();
		panel_bottom.setLayout(new FlowLayout(FlowLayout.RIGHT));
		getContentPane().add(panel_bottom, BorderLayout.SOUTH);
		{
			b_close = new JButton("閉じる");
			b_close.addActionListener(this);
			panel_bottom.add(b_close);
		}
	}

	@Override
	protected void update_font() {
		Font font = get_font();
		
		b_add.setFont(font);
		b_del.setFont(font);
		b_dup.setFont(font);
		b_close.setFont(font);
		list_left.setFont(font);
		this.setFont(font);
	}
	
	public void valueChanged(ListSelectionEvent e) {
		if(e.getSource() == list_left) {
			select_left_list(list_left.getSelectedIndex());
		}
	}
	
	public void actionPerformed(ActionEvent e) {
		if(e.getSource() == b_add) {
			select_add();
		}
		if(e.getSource() == b_del) {
			select_del();
		}
		if(e.getSource() == b_dup) {
			select_dup();
		}
		if(e.getSource() == b_close) {
			this.setVisible(false);
		}
	}
	
	int get_selected_index(JList list){
		int[] index = list.getSelectedIndices();
		if(index.length == 1){
			return index[0];
		}
		else return -1;
	}
	
	abstract protected void select_left_list(int index);
	abstract protected void select_add();
	abstract protected void select_del();
	abstract protected void select_dup();
	
}
