import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Component;
import java.awt.FlowLayout;
import java.awt.Font;
import java.awt.event.ActionEvent;
import java.util.ArrayList;

import javax.swing.BoxLayout;
import javax.swing.DefaultListModel;
import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JSplitPane;
import javax.swing.JTextArea;
import javax.swing.JTextField;
import javax.swing.border.LineBorder;
import javax.swing.event.DocumentEvent;
import javax.swing.event.DocumentListener;
import javax.swing.event.ListSelectionEvent;
import javax.swing.undo.UndoManager;


public class Dialog_Base_State_List extends Dialog_2Pain implements DocumentListener {
	protected JLabel l_label_title;
	protected JLabel l_name_title;
	protected JTextArea ta_label;
	protected UndoManager ta_label_mgr;
	protected JTextField tf_name;
	protected UndoManager tf_name_mgr;
	protected JTextField tf_extends;
	protected UndoManager tf_extends_mgr;
	protected JLabel l_end;
	protected JLabel l_field_default;
	protected JTextArea ta_field_usr;
	protected UndoManager ta_field_usr_mgr;
	
	protected Model_Base_State sel_base_state = null;
	
	protected boolean is_change_listener_enable = true;
	
	Dialog_Base_State_List(MyFrame _frame, Model_Root _model_root){
		super(_frame, _model_root, "状態の一覧");
		
		create_view();
		update_data();
		
		this.repaint();
	}
	
	@Override
	protected void create_view() {
		super.create_view();
		this.setSize(500, 300);
		
		//Base State Editを配置

		//text_boxsパネルを配置
		JPanel text_boxs_panel = new JPanel();
		text_boxs_panel.setLayout(new BorderLayout());
		panel_right.add(text_boxs_panel, BorderLayout.NORTH);
		{				
			//ラベルのパネルを配置
			JPanel label_panel = new JPanel();
			label_panel.setLayout(new BoxLayout(label_panel, BoxLayout.LINE_AXIS));
			text_boxs_panel.add(label_panel, BorderLayout.NORTH);
			{
				l_label_title = new JLabel("表示名 : ", JLabel.LEFT);
				l_label_title.setAlignmentX(Component.LEFT_ALIGNMENT);
				label_panel.add(l_label_title);
				
				ta_label = new JTextArea("");
				ta_label.setTabSize(2);
				ta_label.setRows(1);
				ta_label.setBorder(new LineBorder(Color.GRAY, 1));
				ta_label.getDocument().addDocumentListener(this);
				ta_label_mgr = new UndoManager();
				init_undo_mgr(ta_label, ta_label_mgr);
				label_panel.add(ta_label);
			}
			
			//state name のパネルを配置
			JPanel name_panel = new JPanel();
			name_panel.setLayout(new BoxLayout(name_panel, BoxLayout.LINE_AXIS));
			text_boxs_panel.add(name_panel, BorderLayout.SOUTH);
			{
				l_name_title = new JLabel("状態名 : ", JLabel.LEFT);
				l_name_title.setAlignmentX(Component.LEFT_ALIGNMENT);
				name_panel.add(l_name_title);
							
				tf_name = new JTextField("");
				tf_name.getDocument().addDocumentListener(this);
				tf_name_mgr = new UndoManager();
				init_undo_mgr(tf_name, tf_name_mgr);
				name_panel.add(tf_name);
			}
		}
			
		//sig
		JPanel sig_panel = new JPanel();
		sig_panel.setLayout(new BorderLayout());
		
		JScrollPane scroll_pane1 = new JScrollPane();
		scroll_pane1.getVerticalScrollBar().setUnitIncrement(15);
		scroll_pane1.setViewportView(sig_panel);
		panel_right.add(scroll_pane1, BorderLayout.CENTER);
		{	
			JPanel sig_panel2 = new JPanel();
			sig_panel2.setLayout(new BorderLayout());
			sig_panel.add(sig_panel2, BorderLayout.CENTER);
			{
				//sig def
				JPanel sig_def_panel = new JPanel();
				sig_def_panel.setLayout(new BoxLayout(sig_def_panel, BoxLayout.LINE_AXIS));
				sig_def_panel.setBackground(Color.WHITE);
				sig_panel2.add(sig_def_panel, BorderLayout.NORTH);
				{
					//default sig
					l_field_default = new JLabel("");
					l_field_default.setFocusable(false);
					l_field_default.setBackground(Color.WHITE);
					l_field_default.setAlignmentX(Component.LEFT_ALIGNMENT);
					sig_def_panel.add(l_field_default, Component.LEFT_ALIGNMENT);
					
					//extends
					tf_extends = new JTextField("");
					tf_extends.getDocument().addDocumentListener(this);
					tf_extends_mgr = new UndoManager();
					init_undo_mgr(tf_extends, tf_extends_mgr);
					tf_extends.setAlignmentX(Component.LEFT_ALIGNMENT);
					sig_def_panel.add(tf_extends, Component.LEFT_ALIGNMENT);
					
					//{
					l_end = new JLabel(" { ", JLabel.LEFT);
					l_end.setBackground(Color.WHITE);
					l_end.setAlignmentX(Component.LEFT_ALIGNMENT);
					sig_def_panel.add(l_end, Component.LEFT_ALIGNMENT);
				}
				
				//user sig
				ta_field_usr = new JTextArea("");
				ta_field_usr.setTabSize(2);
				ta_field_usr.getDocument().addDocumentListener(this);
				ta_field_usr_mgr = new UndoManager();
				init_undo_mgr(ta_field_usr, ta_field_usr_mgr);
				sig_panel2.add(ta_field_usr, BorderLayout.CENTER);
			}
		}
		
		this.getRootPane().setDefaultButton(b_close);
	}

	
	@Override
	public void update_data() {
		is_change_listener_enable = false;
		list_left_model.clear();
		
		ArrayList<Model_Base_State> list_item = model_root.get_base_state_list();
	    for (int i = 0 ; i < list_item.size() ; i++){
	    	if(list_item.get(i).is_root_state()){
	    		list_left_model.addElement(new String(list_item.get(i).get_state_name() + " (Root State)"));
	    	}
	    	else{
	    		list_left_model.addElement(new String(list_item.get(i).get_state_name()));
	    	}
	    }
	    
	    if(model_root.get_base_state_list().contains(sel_base_state)){
	    	list_left.setSelectedIndex(model_root.get_base_state_list().indexOf(sel_base_state));
	    }
	    else {
	    	sel_base_state = null;
	    }
	    
	    is_change_listener_enable = true;
	    
	    update_base_state_view();
	    update_font();
	}
	
	public void show(){
		update_data();
		
		super.show();
	}
	
	protected void update_base_state_view(){
		Model_Base_State selected = get_selected_base_state();
		
		l_label_title.setVisible(selected != null);
		ta_label.setVisible(selected != null);
		l_name_title.setVisible(selected != null);
    	tf_name.setVisible(selected != null);
    	tf_extends.setVisible(selected != null);
    	l_end.setVisible(selected != null);
    	l_field_default.setVisible(selected != null);
    	ta_field_usr.setVisible(selected != null);
    	
	    if(selected != null){
	    	is_change_listener_enable = false;
	    	
	    	text_update(ta_label, selected.get_label());
	    	text_update(tf_name, selected.get_state_name());
	    	tf_name.setEditable(! selected.is_root_state());
	    	text_update(l_field_default, selected.get_field_default());
	    	text_update(tf_extends, selected.get_extends());
	    	tf_extends.setVisible(! selected.is_root_state());
	    	text_update(ta_field_usr, selected.get_field_usr());
	    	
    		is_change_listener_enable = true;
	    }
	}
	
	protected Model_Base_State get_selected_base_state(){
		int i = get_selected_base_state_index();
		
		if(model_root.get_base_state_list().size() > i && i >= 0){
			return model_root.get_base_state_list().get(i);
		}
		else return null;
	}
	
	protected int get_selected_base_state_index(){
		int[] index = list_left.getSelectedIndices();
		if(index.length == 1){
			return index[0];
		}
		else return -1;
	}
	
	public void set_model(Model_Root _model_root){
		model_root = _model_root;
		update_data();
	}
	
	public void show(Model_Base_State s){
		this.sel_base_state = s;
		
		update_data();
		super.setVisible(true);
	}
	
	protected void apply_text_change() {
		if(is_change_listener_enable){
			Model_Base_State selected = get_selected_base_state();
			
			if(selected != null){
				if(ta_label.getText().equals(selected.get_label()) == false){
					model_root.set_state_label(selected, ta_label.getText());
					if(frame != null){
						if(frame.get_canvas() != null) frame.get_canvas().repaint();
					}
				}
				if(ta_field_usr.getText().equals(selected.get_field_usr()) == false){
					model_root.set_base_state_field(selected, ta_field_usr.getText());
				}
				if(tf_name.getText().equals(selected.get_state_name()) == false){
					model_root.set_base_state_name(selected, tf_name.getText());
				}
				if(! selected.is_root_state()){
					if(tf_extends.getText().equals(selected.get_extends()) == false){
						model_root.set_base_state_extends(selected, tf_extends.getText());
					}
				}
			}
		}
	}

	public void changedUpdate(DocumentEvent e) {
		apply_text_change();
	}

	public void insertUpdate(DocumentEvent e) {
		apply_text_change();
	}

	public void removeUpdate(DocumentEvent e) {
		apply_text_change();
	}
	
	@Override
	protected void update_font() {
		super.update_font();
		
		Font font = get_font();

		l_label_title.setFont(font);
		l_name_title.setFont(font);
		ta_label.setFont(font);
		tf_name.setFont(font);
		tf_extends.setFont(font);
		l_end.setFont(font);
		l_field_default.setFont(font);
		ta_field_usr.setFont(font);
	}
	
	protected void change_another_base_state_view(){
		update_base_state_view();
	    
		ta_label_mgr.discardAllEdits();
		tf_name_mgr.discardAllEdits();
		tf_extends_mgr.discardAllEdits();
		ta_field_usr_mgr.discardAllEdits();
	}
	
	@Override
	protected void select_left_list(int index) {
		if(is_change_listener_enable){
			sel_base_state = get_selected_base_state();

			change_another_base_state_view();
		}
	}

	@Override
	protected void select_add() {
		model_root.add_base_state(model_root.create_unique_base_state_name(), false);
		update_data();
		
		list_left.setSelectedIndex(list_left_model.getSize() - 1);
	}

	@Override
	protected void select_del() {
		int[] index = list_left.getSelectedIndices();
		if (index.length == 0){
			return;
		}
		else{
			model_root.remove_base_state(index);
		}
	}

	@Override
	protected void select_dup() {
		int[] index = list_left.getSelectedIndices();
		if (index.length > 0){
			ArrayList<Model_Base_State> list_item = model_root.get_base_state_list();
			
			for(int i = 0; i < index.length; i ++){
				if(list_item.get(index[i]).is_root_state() == false){
					model_root.add_base_state("copy_" + list_item.get(index[i]).get_state_name(), false);
					
					list_item = model_root.get_base_state_list();
					model_root.set_base_state_extends(list_item.get(list_item.size() - 1), list_item.get(index[i]).get_extends());
					model_root.set_base_state_field(list_item.get(list_item.size() - 1), list_item.get(index[i]).get_field_usr());
				}
			}
		}
		else{
			return;
		}
	}
	
}
