import java.awt.*;
import java.awt.event.*;
import java.awt.geom.*;
import java.util.ArrayList;
import java.io.Serializable;
import javax.swing.*;
import javax.swing.border.*;
import javax.swing.event.DocumentEvent;
import javax.swing.event.DocumentListener;
import javax.swing.text.JTextComponent;
import javax.swing.undo.UndoManager;

public class Dialog_Error_Alloy extends JDialog{
	protected MyFrame frame = null;
	
	String alloy_text;
	String error_text;

	JTextArea area_error;
	JTextArea area_alloy;
	JLabel label_title;
	
	JButton close_b;
	
	Dialog_Error_Alloy(MyFrame owner, String _title, String _alloy_text, String _error_text){
		super(owner, "エラー", false);
		frame = owner;
		
		this.setLocationByPlatform(true);

		/*****/
		alloy_text = _alloy_text;
		error_text = _error_text;

		this.setSize(600, 600);
		this.setLayout(new BorderLayout(3, 3));
		this.setBackground(Color.WHITE);
		
		//タイトル領域を配置
		label_title = new JLabel(_title);
		getContentPane().add(label_title, BorderLayout.NORTH);
		
		//分割領域を配置
		JSplitPane splitpane = new JSplitPane();
		splitpane.setDividerLocation(300);
		splitpane.setOneTouchExpandable(true);
		getContentPane().add(splitpane, BorderLayout.CENTER);
		{
			//alloy領域
			area_alloy = new JTextArea(alloy_text);
			area_alloy.setTabSize(2);
			area_alloy.setEditable(false);
			area_alloy.setCaretPosition(0);
			
			JScrollPane scroll_pane1 = new JScrollPane();
			scroll_pane1.getVerticalScrollBar().setUnitIncrement(15);
			scroll_pane1.setViewportView(area_alloy);
			scroll_pane1.getViewport().setViewPosition(new Point(0, 0));
			splitpane.setLeftComponent(scroll_pane1);
			
			//エラー領域
			area_error = new JTextArea(error_text);
			area_error.setTabSize(2);
			area_error.setEditable(false);
			area_error.setCaretPosition(0);
			
			JScrollPane scroll_pane2 = new JScrollPane();
			scroll_pane2.getVerticalScrollBar().setUnitIncrement(15);
			scroll_pane2.setViewportView(area_error);
			splitpane.setRightComponent(scroll_pane2);
		}
		
		//Closeボタンを配置
		JPanel button_panel = new JPanel();
		button_panel.setLayout(new FlowLayout(FlowLayout.RIGHT));
		getContentPane().add(button_panel, BorderLayout.SOUTH);
		{
			close_b = new JButton("閉じる");
			close_b.addActionListener(new ActionListener_Dialog_Error_Alloy_Close(this));
			button_panel.add(close_b);
		}
			
		//ショートカットキーの登録
		InputMap imap = this.getRootPane().getInputMap(JComponent.WHEN_ANCESTOR_OF_FOCUSED_COMPONENT);	
		imap.put(KeyStroke.getKeyStroke(KeyEvent.VK_S, java.awt.event.InputEvent.CTRL_MASK), "save");
		this.getRootPane().getActionMap().put("save", new Action_Save_Dialog_Error_Alloy(this));
		
		this.getRootPane().setDefaultButton(close_b);
	}
	
	public void set_source(String _title, String _alloy_text, String _error_text){
		alloy_text = _alloy_text;
		error_text = _error_text;
		label_title.setText(_title);
		area_alloy.setText(alloy_text);
		area_error.setText(_error_text);
		area_alloy.setCaretPosition(0);
		area_error.setCaretPosition(0);
	}
	
	public void dispose(){
		super.dispose();
	}
	
	public void show(){	
		super.show();
	}
	
	public void save_data(){
		frame.save_data_xml();
	}
	
	protected void update_font(){
		Font font = frame.get_font();
		
		area_error.setFont(font);
		area_alloy.setFont(font);
		label_title.setFont(font);
		close_b.setFont(font);
		
		this.setFont(font);
	}
	
	public void setVisible(boolean b){
		if(b) update_font();
		super.setVisible(b);
	}
	
}

class ActionListener_Dialog_Error_Alloy_Close implements ActionListener{
	Dialog_Error_Alloy dialog;
	
	ActionListener_Dialog_Error_Alloy_Close(Dialog_Error_Alloy d){
		dialog = d;
	}
	public void actionPerformed(ActionEvent e) {
		dialog.hide();
    }
}

class Action_Save_Dialog_Error_Alloy extends AbstractAction{
	Dialog_Error_Alloy dialog;
	
	Action_Save_Dialog_Error_Alloy(Dialog_Error_Alloy d){
		dialog = d;
	}
	
	public void actionPerformed(ActionEvent e) {
		dialog.save_data();
	}
}
