import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Component;
import java.awt.Event;
import java.awt.FlowLayout;
import java.awt.Font;
import java.awt.GraphicsEnvironment;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyEvent;
import java.util.Vector;

import javax.swing.BoxLayout;
import javax.swing.InputMap;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JComponent;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;
import javax.swing.KeyStroke;
import javax.swing.undo.UndoManager;


public class Dialog_Font extends Dialog_Base implements ActionListener {
	protected JLabel l_font_title = null;
	protected JComboBox cb_font = null;
	protected JLabel l_font_size_title = null;
	protected JTextField tf_font_size = null;
	protected JButton b_ok = null;
	protected JButton b_cancel = null;
	
	Dialog_Font(MyFrame _frame, Model_Root _model_root){
		super(_frame, _model_root, "フォント設定");
		
		create_view();
		update_data();
	}

	@Override
	protected void create_view() {
		this.setSize(400, 150);
		
		this.setLayout(new BorderLayout(5, 5));
		this.setBackground(Color.WHITE);
		
		JPanel panel = new JPanel();
		panel.setLayout(new BorderLayout());
		getContentPane().add(panel, BorderLayout.NORTH);
		{
			//フォントリスト
			JPanel panel1 = new JPanel();
			panel1.setLayout(new BoxLayout(panel1, BoxLayout.LINE_AXIS));
			panel.add(panel1, BorderLayout.NORTH);
			{
				l_font_title = new JLabel("フォントの種類 : ", JLabel.LEFT);
				l_font_title.setAlignmentX(Component.LEFT_ALIGNMENT);
				panel1.add(l_font_title);
				
				GraphicsEnvironment ge = GraphicsEnvironment.getLocalGraphicsEnvironment();
				Font fonts[] = ge.getAllFonts();
				Vector<String> combodata = new Vector<String>();
				for(int i = 0; i < fonts.length; i ++){
					combodata.add(new String(fonts[i].getFontName()));
				}
				cb_font = new JComboBox(combodata);
				cb_font.setSelectedItem(frame.get_font_name());
				panel1.add(cb_font);
			}
			
			//フォントサイズ
			JPanel panel2 = new JPanel();
			panel2.setLayout(new BoxLayout(panel2, BoxLayout.LINE_AXIS));
			panel.add(panel2, BorderLayout.SOUTH);
			{
				l_font_size_title = new JLabel("フォントのサイズ : ", JLabel.LEFT);
				l_font_size_title.setAlignmentX(Component.LEFT_ALIGNMENT);
				panel2.add(l_font_size_title);
							
				tf_font_size = new JTextField(Integer.toString(frame.get_org_font_size()));
				init_undo_mgr(tf_font_size);
				panel2.add(tf_font_size);
			}
		}
			
		//ボタンを配置
		JPanel button_panel = new JPanel();
		button_panel.setLayout(new FlowLayout(FlowLayout.RIGHT));
		getContentPane().add(button_panel, BorderLayout.SOUTH);
		{				
			b_ok = new JButton("OK");
			b_ok.addActionListener(this);
			button_panel.add(b_ok);
			
			b_cancel = new JButton("キャンセル");
			b_cancel.addActionListener(this);
			button_panel.add(b_cancel);
		}
		
		this.getRootPane().setDefaultButton(b_ok);
	}

	@Override
	public void update_data() {
		
	}

	@Override
	protected void update_font() {
		Font font = get_font();
		
		l_font_size_title.setFont(font);
		l_font_title.setFont(font);
		tf_font_size.setFont(font);
		cb_font.setFont(font);
		b_ok.setFont(font);
		b_cancel.setFont(font);
		this.setFont(font);
	}

	@Override
	protected void set_shortcut_key(){
		InputMap imap = getRootPane().getInputMap(JComponent.WHEN_ANCESTOR_OF_FOCUSED_COMPONENT);
		imap.put(KeyStroke.getKeyStroke(KeyEvent.VK_G, java.awt.event.InputEvent.CTRL_MASK), "hide");
		getRootPane().getActionMap().put("hide", new Shortcut_Action_T(frame, "hide"));
		
		imap.put(KeyStroke.getKeyStroke(KeyEvent.VK_S, java.awt.event.InputEvent.CTRL_MASK), "save");
		getRootPane().getActionMap().put("save", new Shortcut_Action_T(frame, "save"));
	}

	public void actionPerformed(ActionEvent e) {
		if(e.getSource() == b_ok){
			frame.set_font((String)cb_font.getSelectedItem(), Integer.parseInt(tf_font_size.getText()));
			dispose();
		}
		else if(e.getSource() == b_cancel){
			dispose();
		}
	}
}
