import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.FlowLayout;
import java.awt.Font;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JButton;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTabbedPane;
import javax.swing.JTextArea;
import javax.swing.event.DocumentEvent;
import javax.swing.event.DocumentListener;


public class Dialog_Global extends Dialog_Base implements DocumentListener, ActionListener {
	protected Model_Global_Def model;
	
	protected JTextArea ta_grobal_def = null;
	protected JTextArea ta_trace_default = null;
	protected JTextArea ta_trace_def = null;
	protected JButton b_close = null;
	protected JTabbedPane tabbed_pane = null;
	
	Dialog_Global(MyFrame _frame, Model_Root _model_root, Model_Global_Def _model) {
		super(_frame, _model_root, "グローバル定義");
		
		model = _model;
		create_view();
		update_data();
	}

	protected void apply_text_change() {
		if(ta_grobal_def.getText().equals(model.get_def_usr()) == false){
			model_root.set_global_def_usr(ta_grobal_def.getText());
		}
		if(ta_trace_def.getText().equals(model.get_trace_usr()) == false){
			model_root.set_global_trace_usr(ta_trace_def.getText());
		}
	}

	@Override
	protected void create_view() {
		this.setSize(400, 500);		
		this.setLayout(new BorderLayout(3, 3));
		this.setBackground(Color.WHITE);
		
		//Tab
		tabbed_pane = new JTabbedPane();
		getContentPane().add(tabbed_pane, BorderLayout.CENTER);
		
		//Tab1		
		JPanel tab1_panel = new JPanel();
		tab1_panel.setLayout(new BorderLayout());

		JScrollPane scroll_pane1 = new JScrollPane();
		scroll_pane1.getVerticalScrollBar().setUnitIncrement(15);
		scroll_pane1.setViewportView(tab1_panel);
		tabbed_pane.add("グローバル定義", scroll_pane1);
		{		
			//user definition
			ta_grobal_def = new JTextArea();
			ta_grobal_def.setTabSize(2);
			ta_grobal_def.getDocument().addDocumentListener(this);
			init_undo_mgr(ta_grobal_def);
			tab1_panel.add(ta_grobal_def, BorderLayout.CENTER);
		}
		//Tab2
		JPanel tab4_panel = new JPanel();
		tab4_panel.setLayout(new BorderLayout());

		JScrollPane scroll_pane4 = new JScrollPane();
		scroll_pane4.getVerticalScrollBar().setUnitIncrement(15);
		scroll_pane4.setViewportView(tab4_panel);
		tabbed_pane.add("トレース定義", scroll_pane4);
		{
			//default trace
			ta_trace_default = new JTextArea();
			ta_trace_default.setTabSize(2);
			ta_trace_default.setEditable(false);
			ta_trace_default.setFocusable(false);
			tab4_panel.add(ta_trace_default, BorderLayout.NORTH);
			
			//user trace
			ta_trace_def = new JTextArea();
			ta_trace_def.setTabSize(2);
			ta_trace_def.getDocument().addDocumentListener(this);
			init_undo_mgr(ta_trace_def);
			tab4_panel.add(ta_trace_def, BorderLayout.CENTER);
		}
		
		//Closeボタンを配置
		JPanel button_panel = new JPanel();
		button_panel.setLayout(new FlowLayout(FlowLayout.RIGHT));
		getContentPane().add(button_panel, BorderLayout.SOUTH);
		{
			b_close = new JButton("閉じる");
			b_close.addActionListener(this);
			button_panel.add(b_close);
		}
		
		this.getRootPane().setDefaultButton(b_close);
	}

	@Override
	public void update_data() {
		ta_trace_default.setText(model.get_trace_default());
		text_update(ta_grobal_def, model.get_def_usr());
		text_update(ta_trace_def, model.get_trace_usr());
		
		update_font();
	}

	@Override
	protected void update_font() {
		Font font = get_font();
		
		ta_grobal_def.setFont(font);
		ta_trace_default.setFont(font);
		ta_trace_def.setFont(font);
		b_close.setFont(font);
		tabbed_pane.setFont(font);
		this.setFont(font);
	}
	
	public void set_model(Model_Root _model_root, Model_Global_Def _model){
		model_root = _model_root;
		model = _model;
		update_data();
	}
	
	public Model_Global_Def get_model(){
		return model;
	}

	public void changedUpdate(DocumentEvent e) {
		apply_text_change();
	}

	public void insertUpdate(DocumentEvent e) {
		apply_text_change();
	}

	public void removeUpdate(DocumentEvent e) {
		apply_text_change();
	}

	public void actionPerformed(ActionEvent e) {
		if(e.getSource() == b_close){
			setVisible(false);
		}
	}
	
}
