import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.FlowLayout;
import java.awt.Font;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JButton;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.swing.border.LineBorder;
import javax.swing.event.DocumentEvent;
import javax.swing.event.DocumentListener;
import javax.swing.undo.UndoManager;


public class Dialog_Memo extends Dialog_Base implements DocumentListener, ActionListener {
	protected Model_Memo model = null;
	protected JTextArea ta_memo = null;
	protected JButton b_close = null;
	
	Dialog_Memo(MyFrame _frame, Model_Root _model_root, Model_Memo _model) {
		super(_frame, _model_root, "メモ");
		
		model = _model;
		create_view();
		update_data();
	}
	
	@Override
	protected void create_view() {
		this.setSize(300, 200);
		this.setLayout(new BorderLayout(0, 0));
		this.setBackground(Color.WHITE);
		
		//memo本体
		JPanel memo_panel = new JPanel();
		memo_panel.setLayout(new BorderLayout());
		
		JScrollPane scroll_pane = new JScrollPane();
		scroll_pane.getVerticalScrollBar().setUnitIncrement(15);
		scroll_pane.setViewportView(memo_panel);
		getContentPane().add(scroll_pane, BorderLayout.CENTER);
		{		
			ta_memo = new JTextArea(model.get_memo());
			ta_memo.getDocument().addDocumentListener(this);
			ta_memo.setTabSize(2);
			ta_memo.setBorder(new LineBorder(Color.GRAY, 1));
			init_undo_mgr(ta_memo);
			memo_panel.add(ta_memo, BorderLayout.CENTER);
		}
		
		//Closeボタンを配置
		JPanel button_panel = new JPanel();
		button_panel.setLayout(new FlowLayout(FlowLayout.RIGHT));
		getContentPane().add(button_panel, BorderLayout.SOUTH);
		{
			b_close = new JButton("閉じる");
			b_close.addActionListener(this);
			button_panel.add(b_close);
		}
		
		this.getRootPane().setDefaultButton(b_close);
	}

	@Override
	public void update_data() {
		text_update(ta_memo, model.get_memo());
		
		update_font();
	}
	
	@Override
	protected void update_font() {
		Font font = get_font();
		
		ta_memo.setFont(font);
		b_close.setFont(font);
		this.setFont(font);
	}
	
	protected void apply_text_change() {	
		if(ta_memo.getText().equals(model.get_memo()) == false){
			model_root.set_memo(model, ta_memo.getText());
			frame.get_canvas().repaint();
		}
	}
	
	public void set_model(Model_Root _model_root, Model_Memo _model){
		model_root = _model_root;
		model = _model;
		update_data();
	}
	
	public Model_Memo get_model(){
		return model;
	}

	public void changedUpdate(DocumentEvent e) {
		apply_text_change();
	}

	public void insertUpdate(DocumentEvent e) {
		apply_text_change();
	}

	public void removeUpdate(DocumentEvent e) {
		apply_text_change();
	}

	public void actionPerformed(ActionEvent e) {
		if(e.getSource() == b_close){
			setVisible(false);
		}
	}
}
