import java.awt.*;
import java.awt.event.*;
import java.awt.geom.*;
import java.text.DecimalFormat;
import java.util.ArrayList;
import java.io.Serializable;
import javax.swing.*;
import javax.swing.border.*;
import javax.swing.event.DocumentEvent;
import javax.swing.event.DocumentListener;
import javax.swing.text.JTextComponent;
import javax.swing.undo.CannotRedoException;
import javax.swing.undo.CannotUndoException;
import javax.swing.undo.UndoManager;

public class Dialog_Progress extends JDialog implements Serializable, ActionListener{
	protected Dialog_Progress_Listener owner;
	
	protected JTextArea message;
	protected JButton cancel_b;
	protected Thread exec;
	
	Dialog_Progress(JDialog _owner){
		super(_owner, "処理中", true);
		owner = (Dialog_Progress_Listener)_owner;
		
		this.setSize(300, 100);
		
		this.setLayout(new BorderLayout(0, 0));
		
		this.setLocationByPlatform(true);
		this.setDefaultCloseOperation(JDialog.DO_NOTHING_ON_CLOSE);
		
		//message
		{		
			message = new JTextArea("しばらくお待ちください...");
			message.setOpaque(false);
			message.setEditable(false);
			getContentPane().add(message, BorderLayout.CENTER);
		}
		
		//Cancelボタンを配置
		JPanel button_panel = new JPanel();
		button_panel.setLayout(new FlowLayout(FlowLayout.CENTER));
		getContentPane().add(button_panel, BorderLayout.SOUTH);
		{
			cancel_b = new JButton("Cancel");
			cancel_b.addActionListener(this);
			button_panel.add(cancel_b);
		}
		
		this.getRootPane().setDefaultButton(cancel_b);
	}
	
	Dialog_Progress(MyFrame _owner){
		super(_owner, "処理中", true);
		owner = (Dialog_Progress_Listener)_owner;
		
		this.setSize(300, 100);
		
		this.setLayout(new BorderLayout(0, 0));
		
		this.setLocationByPlatform(true);
		this.setDefaultCloseOperation(JDialog.DO_NOTHING_ON_CLOSE);
		
		//message
		{		
			message = new JTextArea("しばらくお待ちください...");
			message.setOpaque(false);
			message.setEditable(false);
			getContentPane().add(message, BorderLayout.CENTER);
		}
		
		//Cancelボタンを配置
		JPanel button_panel = new JPanel();
		button_panel.setLayout(new FlowLayout(FlowLayout.CENTER));
		getContentPane().add(button_panel, BorderLayout.SOUTH);
		{
			cancel_b = new JButton("Cancel");
			cancel_b.addActionListener(this);
			button_panel.add(cancel_b);
		}
		
		this.getRootPane().setDefaultButton(cancel_b);
	}
	
	public void hide_after_show(){
		try {
			while(isVisible() == false){
				Thread.sleep(1000);
			}
		}
		catch (InterruptedException e) {
			e.printStackTrace();
		}
		setVisible(false);
	}
		
	public void dispose(){
		super.dispose();
		owner = null;
	}
	
	public void set_message(String text){
		message.setText(text);
	}

	public void actionPerformed(ActionEvent e) {
		if(e.getSource() == cancel_b){
			owner.progress_cancel_clicked();
		}
	}
	
	public void setVisible(boolean b){
		if(b) update_font();
		super.setVisible(b);
	}
	
	protected void update_font() {
		Font font = owner.get_font();
		
		message.setFont(font);
		cancel_b.setFont(font);
		this.setFont(font);
	}
}