import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Component;
import java.awt.FlowLayout;
import java.awt.Font;
import java.awt.event.ActionEvent;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;
import java.util.ArrayList;

import javax.swing.BoxLayout;
import javax.swing.DefaultListModel;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JSplitPane;
import javax.swing.JTextField;
import javax.swing.ListSelectionModel;
import javax.swing.event.DocumentEvent;
import javax.swing.event.DocumentListener;
import javax.swing.undo.UndoManager;


public class Dialog_Scenario_List extends Dialog_2Pain implements DocumentListener, ItemListener, DnDListChangeListener, Dialog_Progress_Listener {
	JPanel panel_event_list;
	
	JButton b_check;
	JButton b_check_all;
	JButton b_add_event;
	JButton b_del_event;
	
	JLabel l_name;
	JLabel l_start_st;
	JLabel l_event_list;
	JLabel l_end_st;
	
	JComboBox combo_start_st;
	JComboBox combo_end_st;
	
	protected DnDList dnd_list_event;
	protected DefaultListModel model_dnd_list_event;
	
	protected JList list_all_event;
	protected DefaultListModel model_list_all_event;
	
	JTextField tf_name;
	UndoManager tf_name_mgr;
	
	Model_Scenario sel_scenario = null;
	
	boolean is_change_listener_enable = true;
	
	volatile Dialog_Progress d_progress = null;
	volatile Boolean is_cancel_check = false;
	
	
	Dialog_Scenario_List(MyFrame _frame, Model_Root _model_root){
		super(_frame, _model_root, "シナリオの一覧");
		
		d_progress = new Dialog_Progress(this);
		
		create_view();
		update_data();
		
		this.repaint();
	}
	
	@Override
	protected void create_view() {
		super.create_view();
		this.setSize(700, 400);
		
		//シナリオpanel
		{
			//text_boxsパネルを配置
			JPanel text_boxs_panel = new JPanel();
			text_boxs_panel.setLayout(new BorderLayout());
			panel_right.add(text_boxs_panel, BorderLayout.NORTH);
			{				
				//scenario name のパネルを配置
				JPanel name_panel = new JPanel();
				name_panel.setLayout(new BoxLayout(name_panel, BoxLayout.LINE_AXIS));
				text_boxs_panel.add(name_panel, BorderLayout.SOUTH);
				{
					l_name = new JLabel("シナリオ名 : ", JLabel.LEFT);
					l_name.setAlignmentX(Component.LEFT_ALIGNMENT);
					name_panel.add(l_name);
								
					tf_name = new JTextField("");
					tf_name.getDocument().addDocumentListener(this);
					tf_name_mgr = new UndoManager();
					init_undo_mgr(tf_name, tf_name_mgr);
					name_panel.add(tf_name);
				}
			}
				
			//scenario
			JPanel scenario_panel = new JPanel();
			scenario_panel.setLayout(new BorderLayout());
			
			JScrollPane scroll_pane1 = new JScrollPane();
			scroll_pane1.getVerticalScrollBar().setUnitIncrement(15);
			scroll_pane1.setViewportView(scenario_panel);
			panel_right.add(scroll_pane1, BorderLayout.CENTER);
			{	
				//start stateパネルを配置
				JPanel start_st_panel = new JPanel();
				start_st_panel.setLayout(new BorderLayout());
				scenario_panel.add(start_st_panel, BorderLayout.NORTH);
				{
					//ラベル
					l_start_st = new JLabel("初期状態 : ", JLabel.LEFT);
					l_start_st.setAlignmentX(Component.LEFT_ALIGNMENT);
					start_st_panel.add(l_start_st, BorderLayout.WEST);
					
					//Stateのドロップダウンリスト
					combo_start_st = new JComboBox();								
					combo_start_st.addItemListener(this);
					start_st_panel.add(combo_start_st, BorderLayout.CENTER);
				}
				
				//イベントリストパネル
				panel_event_list = new JPanel();
				panel_event_list.setLayout(new BorderLayout());
				scenario_panel.add(panel_event_list, BorderLayout.CENTER);
				{
					//ラベル
					l_event_list = new JLabel("イベント列 : ", JLabel.LEFT);
					l_event_list.setAlignmentX(Component.LEFT_ALIGNMENT);
					panel_event_list.add(l_event_list, BorderLayout.NORTH);
					
					//分割領域を配置
					JSplitPane splitpane2 = new JSplitPane();
					splitpane2.setDividerLocation(150);
					splitpane2.setOneTouchExpandable(false);
					panel_event_list.add(splitpane2, BorderLayout.CENTER);
					{
						//Event seqを配置
						JPanel left_panel2 = new JPanel();
						left_panel2.setLayout(new BorderLayout(3, 3));
						splitpane2.setLeftComponent(left_panel2);
						{
							//リスト領域
							JPanel list_data_panel = new JPanel();
							list_data_panel.setBackground(Color.WHITE);
							list_data_panel.setLayout(new BorderLayout());
							
							JScrollPane scroll_pane = new JScrollPane();
							scroll_pane.getVerticalScrollBar().setUnitIncrement(15);
							scroll_pane.setViewportView(list_data_panel);
							
							left_panel2.add(scroll_pane, BorderLayout.CENTER);
							{
								model_dnd_list_event = new DefaultListModel();
								dnd_list_event = new DnDList();
								dnd_list_event.setModel(model_dnd_list_event);
								dnd_list_event.addListSelectionListener(this);
								dnd_list_event.addDnDListChangeListener(this);
							    list_data_panel.add(dnd_list_event, BorderLayout.WEST);
							}
						}
						
						//Event listを配置
						JPanel panel_right2 = new JPanel();
						panel_right2.setLayout(new BorderLayout(3, 3));
						splitpane2.setRightComponent(panel_right2);
						{
							//ボタン領域
							JPanel event_button_panel = new JPanel();
							event_button_panel.setLayout(new BoxLayout(event_button_panel, BoxLayout.PAGE_AXIS));
							panel_right2.add(event_button_panel, BorderLayout.WEST);
							{
								b_add_event = new JButton("<<");
								b_add_event.addActionListener(this);
								event_button_panel.add(b_add_event);
								
								b_del_event = new JButton("削除");
								b_del_event.addActionListener(this);
								event_button_panel.add(b_del_event);
							}
							
							//リスト領域
							JPanel list_data_panel = new JPanel();
							list_data_panel.setBackground(Color.WHITE);
							list_data_panel.setLayout(new BorderLayout());
							
							JScrollPane scroll_pane = new JScrollPane();
							scroll_pane.getVerticalScrollBar().setUnitIncrement(15);
							scroll_pane.setViewportView(list_data_panel);
							
							panel_right2.add(scroll_pane, BorderLayout.CENTER);
							{
								model_list_all_event = new DefaultListModel();
								list_all_event = new JList(model_list_all_event);
								list_all_event.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
								list_all_event.addListSelectionListener(this);
							    list_data_panel.add(list_all_event, BorderLayout.WEST);
							}
						}
					}
				}
				
				//end stateパネルを配置
				JPanel end_st_panel = new JPanel();
				end_st_panel.setLayout(new BorderLayout());
				scenario_panel.add(end_st_panel, BorderLayout.SOUTH);
				{
					//ラベル
					l_end_st = new JLabel("終了状態 : ", JLabel.LEFT);
					l_end_st.setAlignmentX(Component.LEFT_ALIGNMENT);
					end_st_panel.add(l_end_st, BorderLayout.WEST);
					
					//Stateのドロップダウンリスト
					combo_end_st = new JComboBox();								
					combo_end_st.addItemListener(this);
					end_st_panel.add(combo_end_st, BorderLayout.CENTER);
				}
			}
			
			//ボタンパネルを配置
			JPanel scenario_button_panel = new JPanel();
			scenario_button_panel.setLayout(new FlowLayout(FlowLayout.RIGHT));
			panel_right.add(scenario_button_panel, BorderLayout.SOUTH);
			{				
				b_check = new JButton("シナリオ検査");
				b_check.addActionListener(this);
				scenario_button_panel.add(b_check);
			}
		}
		
		//CheckAllボタンを配置
		{
			panel_bottom.remove(b_close);
			
			b_check_all = new JButton("全シナリオ検査");
			b_check_all.addActionListener(this);
			panel_bottom.add(b_check_all);
			
			panel_bottom.add(b_close);
		}		
	}
	
	@Override
	public void update_data() {
		//シナリオリストを更新
		is_change_listener_enable = false;
		{
			list_left_model.clear();
			ArrayList<Model_Scenario> list_item = model_root.get_scenario_list();
		    for (int i = 0 ; i < list_item.size() ; i++){
		    	list_left_model.addElement(new String(list_item.get(i).get_name() + " (" + list_item.get(i).check_state + ")"));
		    }
		    if(model_root.get_scenario_list().contains(sel_scenario)){
		    	list_left.setSelectedIndex(model_root.get_scenario_list().indexOf(sel_scenario));
		    }
		    else {
		    	sel_scenario = null;
		    }
		}
	    is_change_listener_enable = true;
		
	    //シナリオを更新
	    update_scenario_view();
	    
	    update_font();
	}

	void update_scenario_view(){	
		l_name.setVisible(sel_scenario != null);
		l_start_st.setVisible(sel_scenario != null);
		l_event_list.setVisible(sel_scenario != null);
		l_end_st.setVisible(sel_scenario != null);
		b_check.setVisible(sel_scenario != null);
		b_add_event.setVisible(sel_scenario != null);
		b_del_event.setVisible(sel_scenario != null);
		combo_end_st.setVisible(sel_scenario != null);
		combo_start_st.setVisible(sel_scenario != null);
		dnd_list_event.setVisible(sel_scenario != null);
		list_all_event.setVisible(sel_scenario != null);
		tf_name.setVisible(sel_scenario != null);
		panel_event_list.setVisible(sel_scenario != null);
    	
	    if(sel_scenario != null){
	    	is_change_listener_enable = false;
	    	
	    	text_update(tf_name, sel_scenario.get_name());
    		
	    	update_state_list(combo_start_st, sel_scenario.start_st);
	    	update_state_list(combo_end_st, sel_scenario.end_st);
	    	
	    	//イベント列を更新
	    	model_dnd_list_event.clear();
			ArrayList<Model_Event> list_item = sel_scenario.get_event_list();
		    for (int i = 0 ; i < list_item.size() ; i++){
		    	model_dnd_list_event.addElement(new String(list_item.get(i).get_full_name()));
		    }
	    	
	    	//all event listを更新
		    model_list_all_event.clear();
			ArrayList<Model_Event> list_item2 = model_root.get_event_list();
		    for (int i = 0 ; i < list_item2.size() ; i++){
		    	model_list_all_event.addElement(new String(list_item2.get(i).get_full_name()));
		    }
    		
    		is_change_listener_enable = true;
	    }
	}
	
	void update_state_list(JComboBox combo, Model_State sel_state){
		//リスト作成
		combo.removeItemListener(this);
		{
			Boolean is_change = false;
	    	
			ArrayList<Model_State> state_list = model_root.get_state_list();
			if(state_list.size() == combo.getItemCount()){
				for(int i = 0; i < state_list.size(); i ++){
					if(state_list.get(i).get_base_state_name().equals(combo.getItemAt(i)) == false){
						is_change = true;
					}
				}
			}
			else{
				is_change = true;
			}
			
			if(is_change == true){
				combo.removeAllItems();
				for(int i = 0; i < state_list.size(); i ++){
					combo.addItem(new String(state_list.get(i).get_base_state_name()));
				}
			}
			
			//選択
			if(sel_state == null){
				combo.setSelectedIndex(-1);
			}
			else{
				combo.setSelectedIndex(model_root.get_state_list().indexOf(sel_state));
			}
		}
		combo.addItemListener(this);
	}
	
	public void set_model(Model_Root _model_root){
		model_root = _model_root;
		update_data();
	}
	
	@Override
	protected void update_font() {
		super.update_font();
		
		Font font = get_font();

		b_check.setFont(font);
		b_check_all.setFont(font);
		b_add_event.setFont(font);
		b_del_event.setFont(font);
		l_name.setFont(font);
		l_start_st.setFont(font);
		l_event_list.setFont(font);
		l_end_st.setFont(font);
		combo_start_st.setFont(font);
		combo_end_st.setFont(font);
		dnd_list_event.setFont(font);
		list_all_event.setFont(font);
		tf_name.setFont(font);
	}

	@Override
	protected void select_add() {
		sel_scenario = model_root.add_scenario(model_root.create_unique_scenario_name());
		update_data();
		
		list_left.setSelectedIndex(list_left_model.getSize() - 1);
	}

	@Override
	protected void select_del() {
		int[] index = list_left.getSelectedIndices();
		if (index.length == 0){
			return;
		}
		else{
			model_root.remove_scenario(index);
		}
	}

	@Override
	protected void select_dup() {
		int[] index = list_left.getSelectedIndices();
		if (index.length > 0){
			ArrayList<Model_Scenario> list_item = model_root.get_scenario_list();
			
			for(int i = 0; i < index.length; i ++){
				model_root.add_scenario("copy_" + list_item.get(index[i]).get_name());
			}
		}
	}

	@Override
	protected void select_left_list(int index) {
		if(is_change_listener_enable){
			sel_scenario = get_selected_scenario();

			change_another_scenario_view();
		}
	}
	
	protected Model_Scenario get_selected_scenario(){
		int i = get_selected_scenario_index();
		
		if(model_root.get_event_list().size() > i && i >= 0){
			return model_root.get_scenario_list().get(i);
		}
		else return null;
	}
	
	protected int get_selected_scenario_index(){
		int[] index = list_left.getSelectedIndices();
		if(index.length == 1){
			return index[0];
		}
		else return -1;
	}
	
	protected void change_another_scenario_view(){
		update_scenario_view();
	    
		tf_name_mgr.discardAllEdits();
	}

	public void changedUpdate(DocumentEvent e) {
		apply_text_change();
	}

	public void insertUpdate(DocumentEvent e) {
		apply_text_change();
	}

	public void removeUpdate(DocumentEvent e) {
		apply_text_change();
	}
	
	protected void apply_text_change() {
		if(is_change_listener_enable){
			if(tf_name.getText().equals(sel_scenario.get_name()) == false){
				model_root.set_scenario_name(sel_scenario, tf_name.getText());
			}
		}
	}

	public void itemStateChanged(ItemEvent e) {
		if(e.getItemSelectable() == combo_start_st) {
			if (e.getStateChange() == ItemEvent.SELECTED){
				int k = combo_start_st.getSelectedIndex();
				if(k >= 0){
					if(sel_scenario.start_st != model_root.get_state_list().get(k)){
						sel_scenario.start_st = model_root.get_state_list().get(k);
					}
				}
				else{
					if(sel_scenario.start_st != null){
						sel_scenario.start_st = null;
					}
				}
			}
		}
		else if(e.getItemSelectable() == combo_end_st) {
			if (e.getStateChange() == ItemEvent.SELECTED){
				int k = combo_end_st.getSelectedIndex();
				if(k >= 0){
					if(sel_scenario.end_st != model_root.get_state_list().get(k)){
						sel_scenario.end_st = model_root.get_state_list().get(k);
					}
				}
				else{
					if(sel_scenario.end_st != null){
						sel_scenario.end_st = null;
					}
				}
			}
		}
	}

	public void listSortChange(DnDList source, int from, int to) {
		if(source == dnd_list_event){	
			Model_Event tgt = sel_scenario.event_list.get(from);
			
			if(to == from) {
            }
			else if(to < from) {
				sel_scenario.event_list.remove(from);
				sel_scenario.event_list.add(to, tgt);
            }
			else{
				sel_scenario.event_list.add(to, tgt);
				sel_scenario.event_list.remove(from);
            }
		}
	}
	
	@Override
	public void actionPerformed(ActionEvent e) {
		super.actionPerformed(e);
		
		if(e.getSource() == b_check){
			is_cancel_check = false;
			Check_Scenario_Thread thread = new Check_Scenario_Thread(this, sel_scenario);
			thread.start();
			d_progress.setTitle(sel_scenario.get_name());
			d_progress.set_message("チェック中...");
			d_progress.setVisible(true);
			is_cancel_check = false;
			
			this.update_data();
		}
		else if(e.getSource() == b_check_all){
			is_cancel_check = false;
			Check_All_Scenario_Thread thread = new Check_All_Scenario_Thread(this);
			thread.start();
			d_progress.setTitle("全シナリオ検査");
			d_progress.setVisible(true);
			is_cancel_check = false;
		}
		else if(e.getSource() == b_add_event){
			Model_Event selected_all_event = get_selected_all_event();
			if(selected_all_event != null){
				sel_scenario.get_event_list().add(selected_all_event);
				update_scenario_view();
			}
		}
		else if(e.getSource() == b_del_event){
			int[] index = dnd_list_event.getSelectedIndices();
			if (index.length == 0){
				return;
			}
			else{
				Model_Scenario scenario = sel_scenario;
				for (int i = index.length - 1 ; i >= 0 ; i--){
					scenario.event_list.remove(index[i]);
				}
				update_scenario_view();
			}
		}
	}
	
	Model_Event get_selected_all_event(){
		int i = get_selected_index(list_all_event);
		
		if(model_root.get_event_list().size() > i && i >= 0){
			return model_root.get_event_list().get(i);
		}
		else return null;
	}
	
	void check_all_scenario(){
		ArrayList<Model_Scenario> scenario_list = model_root.get_scenario_list();
		for(int i = 0; i < scenario_list.size(); i ++){
			d_progress.set_message("全チェック中...\n" + (i + 1) + "/" + scenario_list.size());
			
			if(is_cancel_check){
				break;
			}
			else{
				check_scenario(scenario_list.get(i), false);
				this.update_data();
			}
		}
		
		d_progress.hide_after_show();
		this.update_data();
		
		if(is_cancel_check == false){
			JOptionPane.showMessageDialog(this, "全チェック完了", "結果", JOptionPane.PLAIN_MESSAGE);
		}
		
		is_cancel_check = false;
	}
	
	void check_scenario(Model_Scenario scenario, Boolean is_show_ret_dialog){
		String alloy = "";
		alloy += model_root.get_alloy() + "\n" + scenario.get_alloy_run_command();
		
		Alloy_result ret = new Alloy_result();
		ret = frame.exec_alloy(alloy, "command", scenario.get_scenario_pred_name());
		
		if(is_show_ret_dialog){
			d_progress.hide_after_show();
		}
		
		if(ret.ret == Alloy_result.CANCELED){

		}
		else if(ret.ret == Alloy_result.CHECK_OK){
			scenario.check_state = "チェックOK";
			if(is_show_ret_dialog){
				JOptionPane.showMessageDialog(this, "チェックOK", "結果", JOptionPane.PLAIN_MESSAGE);
			}
		}
		else if (ret.ret == Alloy_result.NO_INSTANCE_FOUND){
			scenario.check_state = "チェックNG";
			if(is_show_ret_dialog){
				frame.show_Dialog_Error_Alloy("No instance found.", alloy, scenario.get_alloy_run_command() + ret.ret_text);
			}
		}
		else{
			scenario.check_state = "チェック失敗";
			if(is_show_ret_dialog){
				frame.show_Dialog_Error_Alloy("構文・型チェック NG", alloy, scenario.get_alloy_run_command() + ret.ret_text);
			}
		}
	}

	public void progress_cancel_clicked() {
		is_cancel_check = true;
		frame.cancel_exec_alloy();
	}
}

class Check_Scenario_Thread extends Thread{
	Dialog_Scenario_List owner;
	Model_Scenario scenario;
	
	Check_Scenario_Thread(Dialog_Scenario_List _owner, Model_Scenario _scenario){
		super();
		owner = _owner;
		scenario = _scenario;
	}
	
	public void run() {
		owner.check_scenario(scenario, true);
	}
}

class Check_All_Scenario_Thread extends Thread{
	Dialog_Scenario_List owner;
	
	Check_All_Scenario_Thread(Dialog_Scenario_List _owner){
		super();
		owner = _owner;
	}
	
	public void run() {
		owner.check_all_scenario();
	}
}
