import java.awt.BorderLayout;
import java.awt.CardLayout;
import java.awt.Color;
import java.awt.Component;
import java.awt.FlowLayout;
import java.awt.Font;
import java.awt.Point;
import java.awt.event.ActionEvent;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;
import java.io.StringReader;
import java.util.ArrayList;

import javax.swing.DefaultListModel;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTable;
import javax.swing.JTextArea;
import javax.swing.table.DefaultTableModel;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;

import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.NodeList;
import org.xml.sax.InputSource;
import org.xml.sax.SAXException;


class Sig_Data{
	public String org_sig_def = "";
	public String org_sig_name = "";
	public String show_sig_def = "";
	public String show_sig_name = "";
	public int instance_num = 3;
	public ArrayList<String> instance_name_list = null;
	
	Sig_Data(String _org_sig_def){
		instance_name_list = new ArrayList<String>();
		org_sig_def = _org_sig_def;
		org_sig_name = get_org_sig_name();
		show_sig_def = org_sig_def.replaceAll("this/", "");
		show_sig_name = org_sig_name.replaceAll("this/", "");
	}
	
	String get_org_sig_name(){
		String name = "";
		
		name = org_sig_def.replaceFirst("^.*sig", "");
		name = name.replaceAll("extends.*", "");
		name = name.replaceAll(" ", "");
						
		return name;
	}
}

public class Dialog_Simulation extends Dialog_2Pain implements Dialog_Progress_Listener, ItemListener{
	CardLayout layout_right;
	
	JPanel panel_init;
	JLabel l_init_state;
	JComboBox combo_init_state;
	JLabel l_init_sig;
	JTable table_init_sig;
	DefaultTableModel table_init_sig_model;
	JButton b_init_start;
	
	JPanel panel_instance;
	JLabel l_instance_title;
	JTextArea ta_instance_val;
	JLabel l_instance_event;
	JComboBox combo_instance_event;
	JButton b_instance_start;
	
	ArrayList<ArrayList<String>> instance_data_list;
	ArrayList<String> in_param_data_list;
	ArrayList<Model_Event> next_event_list;
	
	ArrayList<Sig_Data> sig_list;
	
	volatile Dialog_Progress d_progress = null;
	volatile Boolean is_cancel_check = false;
	
	Dialog_Simulation(MyFrame _frame, Model_Root _model_root){
		super(_frame, _model_root, "シミュレーション");
		
		d_progress = new Dialog_Progress(this);
		instance_data_list = new ArrayList<ArrayList<String>>();
		in_param_data_list = new ArrayList<String>();
		next_event_list = new ArrayList<Model_Event>();
		sig_list = new ArrayList<Sig_Data>();
		
		create_view();
		update_data();
		
		this.repaint();
	}
	
	@Override
	protected void create_view() {
		super.create_view();
		this.setSize(600, 300);
	
		layout_right = new CardLayout();
		panel_right.setLayout(layout_right);
		{
			//init panel
			panel_init = new JPanel();
			panel_init.setLayout(new BorderLayout());
			panel_right.add(panel_init, "init");
			{
				//設定本体
				JPanel set_panel = new JPanel();
				set_panel.setLayout(new BorderLayout());
				panel_init.add(set_panel, BorderLayout.CENTER);
				{
					//初期状態
					JPanel init_state_panel = new JPanel();
					init_state_panel.setLayout(new BorderLayout());
					set_panel.add(init_state_panel, BorderLayout.NORTH);
					{
						l_init_state = new JLabel("初期状態:", JLabel.LEFT);
						l_init_state.setAlignmentX(Component.LEFT_ALIGNMENT);
						init_state_panel.add(l_init_state, BorderLayout.WEST);
						
						//stateのドロップダウンリスト
						combo_init_state = new JComboBox();
						combo_init_state.addItemListener(this);
						init_state_panel.add(combo_init_state, BorderLayout.CENTER);
					}
					
					//sig インスタンス数
					JPanel init_sig_num_panel = new JPanel();
					init_sig_num_panel.setLayout(new BorderLayout());
					set_panel.add(init_sig_num_panel, BorderLayout.CENTER);
					{
						//タイトル
						l_init_sig = new JLabel("sig のインスタンス数:");
						l_init_sig.setAlignmentX(Component.LEFT_ALIGNMENT);
						init_sig_num_panel.add(l_init_sig, BorderLayout.NORTH);
						
						//テーブル
						table_init_sig = new JTable();
						table_init_sig.setShowGrid(true);
						table_init_sig.setGridColor(Color.GRAY);
						
						JScrollPane scroll_pane1 = new JScrollPane(table_init_sig);
						init_sig_num_panel.add(scroll_pane1, BorderLayout.CENTER);
					}
				}
				
				//Startボタンを配置
				JPanel button_panel = new JPanel();
				button_panel.setLayout(new FlowLayout(FlowLayout.RIGHT));
				panel_init.add(button_panel, BorderLayout.SOUTH);
				{
					b_init_start = new JButton("開始");
					b_init_start.addActionListener(this);
					button_panel.add(b_init_start);
				}
			}
			

			//instance panel
			panel_instance = new JPanel();
			panel_instance.setLayout(new BorderLayout());
			panel_right.add(panel_instance, "instance");
			{
				//内容
				JPanel set_panel = new JPanel();
				set_panel.setLayout(new BorderLayout());
				panel_instance.add(set_panel, BorderLayout.CENTER);
				{
					//instance
					JPanel instance_data_panel = new JPanel();
					instance_data_panel.setLayout(new BorderLayout());
					set_panel.add(instance_data_panel, BorderLayout.CENTER);
					{
						//タイトル
						l_instance_title = new JLabel("現在の状態", JLabel.LEFT);
						l_instance_title.setAlignmentX(Component.LEFT_ALIGNMENT);
						instance_data_panel.add(l_instance_title, BorderLayout.NORTH);
						l_instance_title.hide();
						
						//インスタンスの値
						ta_instance_val = new JTextArea();
						ta_instance_val.setTabSize(2);
						ta_instance_val.setEditable(false);
						ta_instance_val.setCaretPosition(0);
						
						JScrollPane scroll_pane1 = new JScrollPane();
						scroll_pane1.getVerticalScrollBar().setUnitIncrement(15);
						scroll_pane1.setViewportView(ta_instance_val);
						scroll_pane1.getViewport().setViewPosition(new Point(0, 0));
						instance_data_panel.add(scroll_pane1, BorderLayout.CENTER);
					}
					
					//next event
					JPanel next_event_panel = new JPanel();
					next_event_panel.setLayout(new BorderLayout());
					set_panel.add(next_event_panel, BorderLayout.SOUTH);
					{
						l_instance_event = new JLabel("次のイベント:", JLabel.LEFT);
						l_instance_event.setAlignmentX(Component.LEFT_ALIGNMENT);
						next_event_panel.add(l_instance_event, BorderLayout.WEST);
						
						//stateのドロップダウンリスト
						combo_instance_event = new JComboBox();							
						combo_instance_event.addItemListener(this);
						next_event_panel.add(combo_instance_event, BorderLayout.CENTER);
					}
				}
				
				//Startボタンを配置
				JPanel button_panel = new JPanel();
				button_panel.setLayout(new FlowLayout(FlowLayout.RIGHT));
				panel_instance.add(button_panel, BorderLayout.SOUTH);
				{
					b_instance_start = new JButton("次の状態に遷移");
					b_instance_start.addActionListener(this);
					button_panel.add(b_instance_start);
				}
			}
		}
		
		panel_left.remove(event_button_panel);
		
		update_font();
	}
	
	@Override
	public void update_data() {	
		if(this.isVisible()){
			sig_list_update();
			sig_table_update();
			instance_list_update();
			init_state_list_update();
			instance_event_list_update();
			
			update_font();
		}
	}
	
	protected void sig_table_update(){
		String[][] sig_def_list = new String[sig_list.size()][2];
		for(int i = 0; i < sig_list.size(); i ++){
			sig_def_list[i][0] = sig_list.get(i).show_sig_def;
			sig_def_list[i][1] = "" + sig_list.get(i).instance_num;
		}
		String[] columnNames = {"sig", "インスタンス数"};

		
		table_init_sig_model = new DefaultTableModel(sig_def_list, columnNames);
		table_init_sig.setModel(table_init_sig_model);

	}
	
	protected void sig_list_update(){
		is_cancel_check = false;
		Check_Sig_Thread thread = new Check_Sig_Thread(this);
		thread.start();
		d_progress.setTitle("初期化中");
		d_progress.setVisible(true);
		if(is_cancel_check){
			this.setVisible(false);
		}
		is_cancel_check = false;
	}
	
	protected void sig_list_update_local(){
		String alloy = model_root.get_alloy();
		
		Alloy_result ret = new Alloy_result();
		ret = frame.exec_alloy(alloy, "get_sig_list", "");
		
		d_progress.hide_after_show();

		if(is_cancel_check == false){
			String result = ret.ret_text;
			if (ret.ret == Alloy_result.SYNTAX_TYPE_ERROR){
				//frame.show_Dialog_Error_Alloy("構文・型チェック NG", alloy, result);
				result = "";
			}
			else if(ret.ret == Alloy_result.NO_INSTANCE_FOUND){
				//frame.show_Dialog_Error_Alloy("No instance found.", alloy, result);
				result = "";
			}
			else if(ret.ret == Alloy_result.SYNTAX_TYPE_ERROR){
				//JOptionPane.showMessageDialog(this, "内部エラー(" + ret + ")", "結果", JOptionPane.ERROR_MESSAGE);
				result = "";
			}
		
			sig_list.clear();
			if(result.equals("") == false){
				ArrayList<Model_Base_State> base_state_list = model_root.get_base_state_list();
				String[] list = result.split("\n");
				for(int i = 0; i < list.length; i ++){
					Sig_Data sig = new Sig_Data(list[i]);
					
					boolean is_base = false;
					for(int j = 0; j < base_state_list.size(); j ++){
						if(base_state_list.get(j).get_state_name().equals(sig.show_sig_name)){
							is_base = true;
						}
					}
					if(is_base == false){
						sig_list.add(sig);
					}
				}
			}
		}
	}
	
	protected void instance_list_update(){		
		list_left_model.clear();
		list_left_model.add(0, "初期設定");
		for(int i = 0; i < instance_data_list.size(); i ++){
			if(i == 0){
				list_left_model.add(1 + i, "初期状態");
			}
			else{
				list_left_model.add(1 + i, next_event_list.get(i - 1).get_full_name());
			}
		}
	}
	
	protected void init_state_list_update(){
		boolean is_change = false;
		ArrayList<Model_State> state_model_list = model_root.get_state_list();
	
		if(state_model_list.size() == combo_init_state.getItemCount()){
			for(int i = 0; i < state_model_list.size(); i ++){
				if(state_model_list.get(i).get_base_state_name().equals(combo_init_state.getItemAt(i)) == false){
					is_change = true;
				}
			}
		}
		else is_change = true;
		
		if(is_change == true){
	
			combo_init_state.removeAllItems();
			for(int i = 0; i < state_model_list.size(); i ++){
				combo_init_state.addItem(new String(state_model_list.get(i).get_base_state_name()));
			}
		}
	}
	
	protected void instance_event_list_update(){
		boolean is_change = false;
		ArrayList<Model_Event> event_model_list = model_root.get_event_list();
		
		if(event_model_list.size() == combo_instance_event.getItemCount()){
			for(int i = 0; i < event_model_list.size(); i ++){
				if(event_model_list.get(i).get_full_name().equals(combo_instance_event.getItemAt(i)) == false){
					is_change = true;
				}
			}
		}
		else is_change = true;
		
		if(is_change == true){
			combo_instance_event.removeAllItems();
			for(int i = 0; i < event_model_list.size(); i ++){
				combo_instance_event.addItem(new String(event_model_list.get(i).get_full_name()));
			}
		}
	}
	
	public void show(){
		super.show();
		reset_all_data();
		list_left.setSelectedIndex(0);
	}
	
	protected void reset_all_data(){	
		instance_data_list.clear();
		next_event_list.clear();
		in_param_data_list.clear();
		combo_init_state.removeAllItems();
		combo_instance_event.removeAllItems();
		list_left_model.clear();
		show_panel_init();
		update_data();
	}
	
	public void set_model(Model_Root _model_root){
		model_root = _model_root;
		update_data();
	}
	
	@Override
	protected void update_font() {
		super.update_font();
		
		Font font = get_font();

		l_init_state.setFont(font);
		combo_init_state.setFont(font);
		l_init_sig.setFont(font);
		table_init_sig.setFont(font);
		b_init_start.setFont(font);
		l_instance_title.setFont(font);
		ta_instance_val.setFont(font);
		l_instance_event.setFont(font);
		combo_instance_event.setFont(font);
		b_instance_start.setFont(font);
	}

	@Override
	protected void select_add() {
		
	}

	@Override
	protected void select_del() {
		
	}

	@Override
	protected void select_dup() {
		
	}

	@Override
	protected void select_left_list(int index) {
		if(index == 0){
	    	show_panel_init();
	    }
	    else if(index > 0){
	    	show_instance_panel(index - 1);
	    }		   
	}

	public void progress_cancel_clicked() {
		is_cancel_check = true;
		frame.cancel_exec_alloy();		
	}

	public void itemStateChanged(ItemEvent e) {
		if(e.getItemSelectable() == combo_instance_event) {
			if (e.getStateChange() == ItemEvent.SELECTED){
				int i = combo_instance_event.getSelectedIndex();
				int instance_index = list_left.getSelectedIndex() - 1;
				
				if(instance_index >= 0 && next_event_list.size() > instance_index && model_root.get_event_list().size() > i){
					next_event_list.set(instance_index, model_root.get_event_list().get(i));
				}
			}
		}
	}
	
	public void actionPerformed(ActionEvent e) {
		super.actionPerformed(e);
		
		if(e.getSource() == b_init_start) {
			init_start();
		}
		if(e.getSource() == b_instance_start) {
			instance_start();
		}
	}
	
	protected void update_sig_instance(String result){
		try {
			DocumentBuilderFactory dbfactory = DocumentBuilderFactory.newInstance();
			DocumentBuilder builder = dbfactory.newDocumentBuilder();
			Document xml = builder.parse(new InputSource(new StringReader(result)));
			
			for(int i = 0; i < sig_list.size(); i ++){
				sig_list.get(i).instance_name_list = get_sig_instances(xml, sig_list.get(i).org_sig_name);
			}

		}
		catch (ParserConfigurationException e) {
			e.printStackTrace();
			return;
		} 
		catch (SAXException e) {
			e.printStackTrace();
			return;
		}
		catch(Exception err) {
			return;
		}
	}
	
	public void init_start(){
		is_cancel_check = false;
		Exec_Init_Thread thread = new Exec_Init_Thread(this);
		thread.start();
		d_progress.setTitle("初期状態作成");
		d_progress.setVisible(true);
		is_cancel_check = false;		
	}
	
	protected void init_start_local(){
		String alloy = create_init_alloy();
		
		//alloy 実行
		String result = "";
		result = exec_simulation(alloy, "simulation");
		
		if(is_cancel_check == false){
			if(result.equals("") == false){
				//fieldの値リスト
				ArrayList<String> field_val_list = get_instance_data(result, "s");
				
				//sig の値リスト
				update_sig_instance(result);
				
				remove_old_instance(0);
				instance_data_list.add(field_val_list);
				in_param_data_list.add("");
				next_event_list.add(model_root.get_event_list().get(0));
				instance_list_update();
				list_left.setSelectedIndex(1);
				show_instance_panel(0);
			}
		}
	}
	
	public void instance_start(){
		is_cancel_check = false;
		Exec_Event_Thread thread = new Exec_Event_Thread(this);
		thread.start();
		int instance_index = list_left.getSelectedIndex() - 1;
		d_progress.setTitle(next_event_list.get(instance_index).get_full_name());
		d_progress.setVisible(true);
		is_cancel_check = false;
	}
	
	protected void instance_start_local(){
		int instance_index = list_left.getSelectedIndex() - 1;
			
		String alloy = create_instance_alloy(instance_data_list.get(instance_index), next_event_list.get(instance_index));
		
		//alloy 実行
		String result = "";
		result = exec_simulation(alloy, "simulation");
		
		if(is_cancel_check == false){
			if(result.equals("") == false){
				//fieldの値リスト
				ArrayList<String> field_val_list = get_instance_data(result, "s'");
				String in_param_vals = get_in_param_data(result, next_event_list.get(instance_index));
				
				remove_old_instance(instance_index + 1);
				instance_data_list.add(field_val_list);
				in_param_data_list.add(in_param_vals);
				next_event_list.add(model_root.get_event_list().get(0));
				instance_list_update();
				list_left.setSelectedIndex(instance_index + 2);
				show_instance_panel(instance_index + 1);
			}
		}
	}
	
	protected void remove_old_instance(int remove_index){
		for(int i = instance_data_list.size() - 1; i >= remove_index; i --){
			instance_data_list.remove(i);
		}
		
		for(int i = in_param_data_list.size() - 1; i >= remove_index; i --){
			in_param_data_list.remove(i);
		}
		
		for(int i = next_event_list.size() - 1; i >= remove_index; i --){
			next_event_list.remove(i);
		}
	}
	
	protected Model_State init_state(){
		return model_root.get_state_list().get(combo_init_state.getSelectedIndex());
	}
	
	protected String create_init_alloy(){
		String alloy = "";
		alloy += model_root.get_alloy() + "\n";
		
		alloy += "pred simulation (s : State){\n";
		alloy += "\t" + "s in " + init_state().get_base_state_name() + "\n";
		alloy += "}\n";
		alloy += "run simulation for 3 but exactly 1 State";
		for(int i = 0; i < sig_list.size(); i ++){
			alloy += ", exactly " + sig_list.get(i).instance_num + " " + sig_list.get(i).show_sig_name;
		}
		alloy += "\n";
			
		return alloy;
	}
	
	protected String create_instance_alloy(ArrayList<String> field_val_list, Model_Event event){	
		String alloy = "";
		alloy += model_root.get_alloy() + "\n";
		
		alloy += "pred simulation" + event.get_alloy_param_def();
		alloy += "\t" + event.get_name() + " [s, s'" + event.get_param_names() + "]\n";
		for(int i = 0; i < field_val_list.size(); i++){
			alloy += "\ts." + field_val_list.get(i) + "\n";
		}
		alloy += "}\n";
		alloy += "run simulation for 3 but exactly 2 State";
		for(int i = 0; i < sig_list.size(); i ++){
			alloy += ", exactly " + sig_list.get(i).instance_num + " " + sig_list.get(i).show_sig_name;
		}
		alloy += "\n";
		
		for(int i = 0; i < sig_list.size(); i ++){
			if(sig_list.get(i).instance_name_list.size() > 0){
				alloy += "one sig ";
				for(int j = 0; j < sig_list.get(i).instance_name_list.size(); j ++){
					if(j > 0) alloy += ", ";
					alloy += sig_list.get(i).instance_name_list.get(j);
				}
				alloy += " extends " + sig_list.get(i).show_sig_name + " {}\n";
			}
		}
			
		return alloy;
	}
	
	protected String exec_simulation(String alloy, String command){	
		Alloy_result ret = new Alloy_result();
		ret = frame.exec_alloy(alloy, "command", command);
		
		d_progress.hide_after_show();
		
		if(ret.ret == Alloy_result.CANCELED){

		}
		else if (ret.ret == Alloy_result.SYNTAX_TYPE_ERROR){
			frame.show_Dialog_Error_Alloy("構文・型チェック NG", alloy, ret.ret_text);
			ret.ret_text = "";
		}
		else if (ret.ret == Alloy_result.NO_INSTANCE_FOUND){
			frame.show_Dialog_Error_Alloy("No instance found.", alloy, ret.ret_text);
			ret.ret_text = "";
		}
		else if (ret.ret == Alloy_result.ALLOY_INTERNAL_ERROR){
			ret.ret_text = "";
		}
		
		return ret.ret_text;
	}
	
	protected String get_in_param_data(String result, Model_Event event){
		String[] param_name_list = event.get_param_names().split(", ");
		
		try {
			DocumentBuilderFactory dbfactory = DocumentBuilderFactory.newInstance();
			DocumentBuilder builder = dbfactory.newDocumentBuilder();
			Document xml = builder.parse(new InputSource(new StringReader(result)));
			
			String ret = "";
			for(int i = 0; i < param_name_list.length; i ++){
				if(param_name_list[i].equals("") == false){
					String param_val = get_instance_param(xml, param_name_list[i]);
					ret += param_val + "\n";
				}
			}

			return ret;
		}
		catch (ParserConfigurationException e) {
			e.printStackTrace();
			return null;
		} 
		catch (SAXException e) {
			e.printStackTrace();
			return null;
		}
		catch(Exception err) {
			return null;
		}
	}
	
	protected ArrayList<String> get_instance_data(String result, String org_state_name){		
		try {
			DocumentBuilderFactory dbfactory = DocumentBuilderFactory.newInstance();
			DocumentBuilder builder = dbfactory.newDocumentBuilder();
			Document xml = builder.parse(new InputSource(new StringReader(result)));
			
			String state_name = get_instance_state(xml, org_state_name);
			ArrayList<String> field_val_list = get_field_value_list(xml, state_name);
			return field_val_list;
		}
		catch (ParserConfigurationException e) {
			e.printStackTrace();
			return null;
		} 
		catch (SAXException e) {
			e.printStackTrace();
			return null;
		}
		catch(Exception err) {
			return null;
		}
	}
	
/*
<skolem label="$test_k" ID="5">
   <tuple> <atom label="0"/> <atom label="7"/> </tuple>
   <tuple> <atom label="1"/> <atom label="-8"/> </tuple>
   <types> <type ID="2"/> <type ID="1"/> </types>
</skolem>	
 */
	protected String get_instance_param(Document xml, String org_param_name){
		String param = "";
		
		Element root = xml.getDocumentElement();
		
		//skolem List
		NodeList s_list = root.getElementsByTagName("skolem");
		for(int i = 0; i < s_list.getLength(); i++){
			Element elem = (Element)s_list.item(i);
			if(elem.getAttribute("label").equalsIgnoreCase("$simulation_" + org_param_name)){
				ArrayList<String> value_list = new ArrayList<String>();
				
				//tuple List
				NodeList t_list = elem.getElementsByTagName("tuple");
				for(int j = 0; j < t_list.getLength(); j++){
					String value = get_param_value((Element)t_list.item(j));
					if(value.equals("") == false){
						value_list.add(value);
					}
				}
				
				if(value_list.size() > 0){
					String comb_word = " + ";
					if(value_list.get(0).indexOf("->") == -1){
						comb_word = " ++ ";
					}
					
					for(int k = 0; k < value_list.size(); k ++){
						if(k > 0){
							param += comb_word;
						}
						param += value_list.get(k);
					}
					
					if(value_list.size() > 1){
						param = "{" + param + "}";
					}
				}
				break;
			}
		}
		
		return org_param_name + " = " + param;	
	}
	
/*
<sig label="this/X1" ID="4" parentID="5">
   <atom label="X1$0"/>
   <atom label="X1$1"/>
   <atom label="X1$2"/>
</sig>
 */
	protected ArrayList<String> get_sig_instances(Document xml, String org_sig_name){
		ArrayList<String> list = new ArrayList<String>();
		
		Element root = xml.getDocumentElement();
		
		//sig List
		NodeList s_list = root.getElementsByTagName("sig");
		for(int i = 0; i < s_list.getLength(); i++){
			Element elem = (Element)s_list.item(i);
			if(elem.getAttribute("label").equalsIgnoreCase(org_sig_name)){
				NodeList a_list = elem.getElementsByTagName("atom");
				for(int j = 0; j < a_list.getLength(); j++){
					Element elem2 = (Element)a_list.item(j);
					String name = elem2.getAttribute("label");
					list.add(name.replace('$', '_'));
				}
			}
		}
		
		return list;
	}
	
	protected String get_instance_state(Document xml, String org_state_name){
		String name = "";
		
		Element root = xml.getDocumentElement();
		
		//skolem List
		NodeList s_list = root.getElementsByTagName("skolem");
		for(int i = 0; i < s_list.getLength(); i++){
			Element elem = (Element)s_list.item(i);
			if(elem.getAttribute("label").equalsIgnoreCase("$simulation_" + org_state_name)){
				NodeList a_list = elem.getElementsByTagName("atom");
				Element elem2 = (Element)a_list.item(0);
				if(elem2 == null){
					name = "";
				}
				else{
					name = elem2.getAttribute("label");
				}
				break;
			}
		}
		
		return name;		
	}

/*
<field label="x" ID="7" parentID="5">
   	<tuple> 
   		<atom label="State$1"/> <atom label="7"/> 
   	</tuple>
   	<tuple> 
   		<atom label="State0$0"/> <atom label="5"/> 
   	</tuple>
   	<tuple> 
   		<atom label="State$0"/> <atom label="0"/> 
   	</tuple>
   	<types> 
   		<type ID="5"/> <type ID="1"/> 
   	</types>
</field>

 */
	
	protected ArrayList<String> get_field_value_list(Document xml, String state_name){
		ArrayList<String> list = new ArrayList<String>();
		
		Element root = xml.getDocumentElement();
		
		//field List
		NodeList f_list = root.getElementsByTagName("field");
		for(int i = 0; i < f_list.getLength(); i++){
			Element elem = (Element)f_list.item(i);
			String field_name = elem.getAttribute("label");
			ArrayList<String> value_list = new ArrayList<String>();
			
			//tuple List
			NodeList t_list = elem.getElementsByTagName("tuple");
			for(int j = 0; j < t_list.getLength(); j++){
				String value = get_field_value((Element)t_list.item(j), state_name);
				if(value.equals("") == false){
					value_list.add(value);
				}
			}
			
			if(value_list.size() > 0){
				String comb_word = " + ";
				if(value_list.get(0).indexOf("->") == -1){
					comb_word = " ++ ";
				}
					
				String field_value = "";
				
				for(int k = 0; k < value_list.size(); k ++){
					if(k > 0){
						field_value += comb_word;
					}
					field_value += value_list.get(k);
				}
				
				if(value_list.size() > 1){
					field_value = "{" + field_value + "}";
				}
				field_value = field_name + " = " + field_value;
				
				list.add(field_value);
			}
		}
		return list;
	}
	
/*
<tuple> <atom label="0"/> <atom label="7"/> </tuple>	
 */
	protected String get_param_value(Element tuple){
		String value = "";
	
		//atom List
		NodeList a_list = tuple.getElementsByTagName("atom");
		for(int i = 0; i < a_list.getLength(); i++){
			Element elem = (Element)a_list.item(i);
			if(i > 0){
				value += "->";
			}
			value += elem.getAttribute("label");
		}
		
		if(value.equals("") == false){
			value = "(" + value + ")";
		}
			
		return value;		
	}
	
/*
<tuple> 
	<atom label="State0$0"/> <atom label="5"/> 
</tuple>
*/
	protected String get_field_value(Element tuple, String state_name){
		String value = "";
	
		//atom List
		NodeList a_list = tuple.getElementsByTagName("atom");
		Element first_elem = (Element)a_list.item(0);
		
		if(first_elem.getAttribute("label").equalsIgnoreCase(state_name)){
			for(int i = 1; i < a_list.getLength(); i++){
				Element elem = (Element)a_list.item(i);
				if(i > 1){
					value += "->";
				}
				value += elem.getAttribute("label");
			}
			
			if(value.equals("") == false){
				value = "(" + value + ")";
			}
		}
			
		return value;		
	}

	public void show_panel_init(){
		layout_right.show(panel_right, "init");
	}
	
	public void show_instance_panel(int index){
		layout_right.show(panel_right, "instance");
		
		String title = "";
		if(index == 0){
			title = "初期状態";
		}
		else{
			title = next_event_list.get(index - 1).get_full_name() + " 後の状態";
		}
		l_instance_title.setText("Instance found.");
		
		String text = "";
		if(sig_list.size() > 0){
			text += "■ sig\n";
			for(int i = 0; i < sig_list.size(); i ++){
				text += sig_list.get(i).show_sig_name + " = {";
				for(int j = 0; j < sig_list.get(i).instance_name_list.size(); j ++){
					if(j > 0){
						text += ", ";
					}
					text += sig_list.get(i).instance_name_list.get(j);
				}
				text += "}\n"; 
			}
			
			text += get_view_text(in_param_data_list.get(index)) + "\n";
		}
		if(in_param_data_list.get(index).equals("") == false){
			text += "■ 引数\n";
			text += get_view_text(in_param_data_list.get(index)) + "\n";
		}
		text += "■ " + title +"\n";
		for(int i = 0; i < instance_data_list.get(index).size(); i ++){
			if(i > 0){
				text += "\n";
			}
			text += get_view_text(instance_data_list.get(index).get(i));
		}
		ta_instance_val.setText(text);
		ta_instance_val.setCaretPosition(0);
		
		if(next_event_list.size() > index){
			combo_instance_event.setSelectedIndex(model_root.get_event_list().indexOf(next_event_list.get(index)));
		}
	}
	
	protected String get_view_text(String text){
		String new_text = "";
		
		new_text = text.replaceAll("\\(", "");
		new_text = new_text.replaceAll("\\)", "");
		new_text = new_text.replaceAll(" \\+\\+", ",");
		new_text = new_text.replaceAll(" \\+", ",");
		
		return new_text;
	}
		
}

class Check_Sig_Thread extends Thread{
	Dialog_Simulation owner;
	
	Check_Sig_Thread(Dialog_Simulation _owner){
		super();
		owner = _owner;
	}
	
	public void run() {
		owner.sig_list_update_local();
	}
}

class Exec_Init_Thread extends Thread{
	Dialog_Simulation owner;
	
	Exec_Init_Thread(Dialog_Simulation _owner){
		super();
		owner = _owner;
	}
	
	public void run() {
		owner.init_start_local();
	}
}

class Exec_Event_Thread extends Thread{
	Dialog_Simulation owner;
	
	Exec_Event_Thread(Dialog_Simulation _owner){
		super();
		owner = _owner;
	}
	
	public void run() {
		owner.instance_start_local();
	}
}
