import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Component;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.Font;
import java.awt.Point;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.util.ArrayList;

import javax.swing.BoxLayout;
import javax.swing.DefaultListModel;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JComboBox;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JSplitPane;
import javax.swing.JTabbedPane;
import javax.swing.JTextArea;
import javax.swing.ListCellRenderer;
import javax.swing.event.DocumentEvent;
import javax.swing.event.DocumentListener;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;


public class Dialog_Trans extends Dialog_Base implements DocumentListener, ActionListener, ItemListener, ListSelectionListener {
	protected Model_Trans model;
	
	protected JLabel l_pred_def = null;
	protected JTextArea ta_usr_pred = null;
	protected JTextArea ta_default_pred = null;
	protected JPanel panel_pred_body = null;
	protected JLabel l_state_src = null;
	protected JLabel l_state_dest = null;
	protected JTextArea ta_comment = null;
	protected JLabel l_event = null;
	protected JButton b_close = null;
	protected JTabbedPane tabbed_pane = null;
	protected JComboBox combo_event = null;
	protected JButton b_event_list = null;
	protected JList list_no_change = null;
	protected DefaultListModel list_no_change_model = null;
	protected JLabel l_no_change = null;
	
	Dialog_Trans(MyFrame _frame, Model_Root _model_root, Model_Trans _model){
		super(_frame, _model_root, "遷移");
		
		model = _model;
		create_view();
		update_data();
	}

	@Override
	protected void create_view() {
		this.setSize(600, 400);
		this.setLayout(new BorderLayout(0, 0));
		this.setBackground(Color.WHITE);
		
		//Tab
		tabbed_pane = new JTabbedPane();
		getContentPane().add(tabbed_pane, BorderLayout.CENTER);
		
		//Tab1		
		JPanel tab1_panel = new JPanel();
		tab1_panel.setLayout(new BorderLayout());
		tabbed_pane.add("Transition", tab1_panel);
		{
			//text_boxsパネルを配置
			JPanel text_boxs_panel = new JPanel();
			text_boxs_panel.setLayout(new BorderLayout());
			tab1_panel.add(text_boxs_panel, BorderLayout.NORTH);
			{
				//タイトル
				l_event = new JLabel("イベント : ", JLabel.LEFT);
				l_event.setAlignmentX(Component.LEFT_ALIGNMENT);
				text_boxs_panel.add(l_event, BorderLayout.WEST);
				
				//イベントのドロップダウンリスト
				ArrayList<Model_Event> event_model_list = model_root.get_event_list();
				combo_event = new JComboBox();			
				combo_event.addItemListener(this);
				text_boxs_panel.add(combo_event, BorderLayout.CENTER);
				
				//イベントリストボタン
				b_event_list = new JButton("...");
				b_event_list.addActionListener(this);
				text_boxs_panel.add(b_event_list, BorderLayout.EAST);			
			}
			
			//split pane
			JSplitPane splitpane = new JSplitPane();
			splitpane.setDividerLocation(150);
		    splitpane.setOrientation(JSplitPane.HORIZONTAL_SPLIT);
		    splitpane.setOneTouchExpandable(true);
		    tab1_panel.add(splitpane, BorderLayout.CENTER);
		    {		
				//predのパネルを配置
				JPanel pred_panel = new JPanel();
				pred_panel.setLayout(new BorderLayout());
				
				JScrollPane scroll_pane1 = new JScrollPane();
				scroll_pane1.getVerticalScrollBar().setUnitIncrement(15);
				scroll_pane1.setViewportView(pred_panel);
				scroll_pane1.setPreferredSize(new Dimension(150, 150));
				scroll_pane1.setMinimumSize(new Dimension(100, 100));
				
				splitpane.setRightComponent(scroll_pane1);
				{
					//pred 定義のパネルを配置
					JPanel pred_def_panel = new JPanel();
					pred_def_panel.setLayout(new BoxLayout(pred_def_panel, BoxLayout.LINE_AXIS));
					pred_def_panel.setBackground(Color.WHITE);
					pred_panel.add(pred_def_panel, BorderLayout.NORTH);
					{
						//pred 
						l_pred_def = new JLabel(model.get_pred_def(), JLabel.LEFT);
						pred_def_panel.add(l_pred_def);
					}
							
					//pred本体のパネル
					panel_pred_body = new JPanel();
					panel_pred_body.setLayout(new BorderLayout());
					pred_panel.add(panel_pred_body, BorderLayout.CENTER);
					{
						//default pred
						ta_default_pred = new JTextArea();
						ta_default_pred.setTabSize(2);
						ta_default_pred.setEditable(false);
						ta_default_pred.setText(model.get_default_pred());
						ta_default_pred.setFocusable(false);
						
						//usr def pred
						JPanel usr_panel_pred_body = new JPanel();
						usr_panel_pred_body.setLayout(new BorderLayout());
						panel_pred_body.add(usr_panel_pred_body, BorderLayout.CENTER);
						{
							//pred本体
							ta_usr_pred = new JTextArea(model.get_pred());
							ta_usr_pred.getDocument().addDocumentListener(this);
							ta_usr_pred.setTabSize(2);
							init_undo_mgr(ta_usr_pred);
							usr_panel_pred_body.add(ta_usr_pred, BorderLayout.CENTER);
						}
					}
				}
				
				//change listパネルを配置
				JPanel list_panel = new JPanel();
				list_panel.setLayout(new BorderLayout());
				splitpane.setLeftComponent(list_panel);
				{
					//タイトル領域
					JPanel list_title_panel = new JPanel();
					list_title_panel.setLayout(new BoxLayout(list_title_panel, BoxLayout.LINE_AXIS));
					list_panel.add(list_title_panel, BorderLayout.NORTH);
					{
						l_no_change = new JLabel("変化しない変数 :", JLabel.LEFT);
						l_no_change.setAlignmentX(Component.LEFT_ALIGNMENT);
						list_title_panel.add(l_no_change, Component.LEFT_ALIGNMENT);
					}
					
					//リスト領域
					JPanel list_data_panel = new JPanel();
					list_data_panel.setBackground(Color.WHITE);
					list_data_panel.setLayout(new BorderLayout());
					
					JScrollPane scroll_pane2 = new JScrollPane();
					scroll_pane2.getVerticalScrollBar().setUnitIncrement(15);
					scroll_pane2.setViewportView(list_data_panel);
					
					list_panel.add(scroll_pane2, BorderLayout.CENTER);
					{
						list_no_change_model = new DefaultListModel();			    
					    list_no_change = new JList(list_no_change_model);
					    MyCellRenderer renderer = new MyCellRenderer();
					    list_no_change.setCellRenderer(renderer);
					    list_no_change.addListSelectionListener(this);
					    list_data_panel.add(list_no_change, BorderLayout.WEST);
					}
				}
		    }
		}
		
		//Tab3
		JPanel tab3_panel = new JPanel();
		tab3_panel.setLayout(new BorderLayout());

		JScrollPane scroll_pane3 = new JScrollPane();
		scroll_pane3.getVerticalScrollBar().setUnitIncrement(15);
		scroll_pane3.setViewportView(tab3_panel);
		tabbed_pane.add("Comment", scroll_pane3);
		{	
			ta_comment = new JTextArea(model.get_comment());
			ta_comment.setTabSize(2);
			ta_comment.getDocument().addDocumentListener(this);
			init_undo_mgr(ta_comment);
			tab3_panel.add(ta_comment, BorderLayout.CENTER);
		}
		
		//Closeボタンを配置
		JPanel button_panel = new JPanel();
		button_panel.setLayout(new FlowLayout(FlowLayout.RIGHT));
		getContentPane().add(button_panel, BorderLayout.SOUTH);
		{
			b_close = new JButton("閉じる");
			b_close.addActionListener(this);
			button_panel.add(b_close);
		}	
		
		this.getRootPane().setDefaultButton(b_close);
	}

	@Override
	public void update_data() {
		list_no_change_model.clear();
		Model_State state = model.get_dest_state();
		if(state != null){
			ArrayList<String> list_item = state.get_valiable_list();
		    for (int i = 0 ; i < list_item.size() ; i++){
		    	JCheckBox cb = new JCheckBox(list_item.get(i), model.is_no_change_valiable(list_item.get(i)));
		    	list_no_change_model.addElement(cb);
		    }
		}
		
		combo_event.removeItemListener(this);
		{
			combo_event_update();
			if(model.get_event() == null){
				combo_event.setSelectedIndex(0);
			}
			else{
				combo_event.setSelectedIndex(model_root.get_event_list().indexOf(model.get_event()) + 1);
			}
		}
		combo_event.addItemListener(this);
	
		text_update(ta_comment, model.get_comment());
		text_update(ta_usr_pred, model.get_pred());
		text_update(l_pred_def, model.get_pred_def());
		text_update(ta_default_pred, model.get_default_pred());

		panel_pred_body.remove(ta_default_pred);		
		if(ta_default_pred.getText().equals("") == false){
			panel_pred_body.add(ta_default_pred, BorderLayout.NORTH);
		}
		
		update_font();
	}
	
	protected void combo_event_update(){
		boolean is_change = false;
		ArrayList<Model_Event> event_model_list = model_root.get_event_list();
		
		if(event_model_list.size() == combo_event.getItemCount() - 1){
			for(int i = 0; i < event_model_list.size(); i ++){
				if(event_model_list.get(i).get_full_name().equals(combo_event.getItemAt(i + 1)) == false){
					is_change = true;
				}
			}
		}
		else is_change = true;
		
		if(is_change == true){
			combo_event.removeAllItems();
			combo_event.addItem("イベント未設定");
			for(int i = 0; i < event_model_list.size(); i ++){
				combo_event.addItem(new String(event_model_list.get(i).get_full_name()));
			}
		}
	}

	@Override
	protected void update_font() {
		Font font = get_font();
		
		combo_event.setFont(font);
		b_event_list.setFont(font);
		l_no_change.setFont(font);
		list_no_change.setFont(font);
		l_pred_def.setFont(font);
		ta_usr_pred.setFont(font);
		ta_default_pred.setFont(font);
		panel_pred_body.setFont(font);
		if(l_state_src != null) l_state_src.setFont(font);
		if(l_state_dest != null) l_state_dest.setFont(font);
		ta_comment.setFont(font);
		l_event.setFont(font);
		b_close.setFont(font);
		tabbed_pane.setFont(font);
		this.setFont(font);
	}
	
	public void set_model(Model_Root _model_root, Model_Trans _model){
		model_root = _model_root;
		model = _model;
		update_data();
	}
	
	public Model_Trans get_model(){
		return model;
	}
	
	protected void apply_text_change() {	
		if(ta_comment.getText().equals(model.get_comment()) == false){
			model_root.set_trans_comment(model, ta_comment.getText());
		}
		else{
			if(combo_event.getSelectedIndex() == 0){
				model_root.set_trans_pred(model, null, ta_usr_pred.getText());
			}
			else{
				model_root.set_trans_pred(model, model_root.get_event_list().get(combo_event.getSelectedIndex() - 1), ta_usr_pred.getText());
			}
		}
	}

	public void changedUpdate(DocumentEvent e) {
		apply_text_change();
	}

	public void insertUpdate(DocumentEvent e) {
		apply_text_change();
	}

	public void removeUpdate(DocumentEvent e) {
		apply_text_change();
	}

	public void actionPerformed(ActionEvent e) {
		if(e.getSource() == b_close){
			setVisible(false);
		}
		else if(e.getSource() == b_event_list){
			frame.show_Dialog_EventList(model.get_event());
		}
	}
	
	
	class MyCellRenderer extends JCheckBox implements ListCellRenderer{
		public MyCellRenderer() {
		}
	
		public Component getListCellRendererComponent(
			JList list,
			Object value,
			int index,
			boolean isSelected,
			boolean cellHasFocus)
		{
			/* 項目の値を読み出して改めて表示する */
			JCheckBox checkBox = (JCheckBox)value;
			setText(checkBox.getText());
			
			setSelected(checkBox.isSelected());
			
			setFont(list_no_change.getFont());
			return this;
		}
	}
		
	public void itemStateChanged(ItemEvent e){
		if(e.getItemSelectable() == combo_event) {
			if (e.getStateChange() == ItemEvent.SELECTED){
				int k = combo_event.getSelectedIndex();
				if(k >= 1){
					if(model.get_event() != model_root.get_event_list().get(k - 1)){
						model_root.set_trans_event(model, model_root.get_event_list().get(k - 1));
						frame.repaint();
					}
				}
				else{
					if(model.get_event() != null){
						model_root.set_trans_event(model, null);
						frame.repaint();
					}
				}
			}
		}
	}

	public void valueChanged(ListSelectionEvent e) {
		if(e.getSource() == list_no_change) {
			int index = list_no_change.getSelectedIndex();
			if(index >= 0){
				Model_State state = model.get_dest_state();
				
				JCheckBox checkBox = (JCheckBox)list_no_change_model.getElementAt(index);
				if (checkBox.isSelected()){
					checkBox.setSelected(false);
					model_root.trans_add_change_valiable(model, checkBox.getText());
				}
				else{
					checkBox.setSelected(true);
					model_root.trans_del_change_valiable(model, checkBox.getText());
				}
			}
		}	
	}
	
	
}


