import java.util.ArrayList;

import org.w3c.dom.Element;


public class Model_Base_State extends Model_Elem {
	public static final String ROOT_STATE_NAME = "State";

	protected String label = "";	//丸の中に表示する名前
	protected String state_name = "";
	protected String usr_extends = "";
	protected String field_usr = "\t\n}\n{\t\n}";
	protected Boolean is_root_state = false;

	
	Model_Base_State(Model_Root _root, String _state_name, Boolean _is_root){
		super(_root);
		
		label = "";
		state_name = _state_name;
		is_root_state = _is_root;
		if(is_root_state == false) usr_extends = ROOT_STATE_NAME;
	}
	
	Model_Base_State(Model_Root _root, Element xml){
		super(_root);
		
		set_xml(xml);
	}
	
	public void set_state_name(String text){
		state_name = text;
	}
	
	public void set_field_usr(String text){
		field_usr = text;
	}
	
	public void set_extends(String text){
		usr_extends = text;
	}
	
	public void set_label(String _label){
		label = _label;
	}
	
	public String get_label(){
		return label;
	}
	
	public String get_label_or_name(){
		if(label.equals("")) return state_name;
		else return label;
	}
	
	public ArrayList<String> get_valiable_list(){
		ArrayList<String> list = new ArrayList<String>();
		
		ArrayList<Model_Base_State> base_state_list = new ArrayList<Model_Base_State>();			
		
		base_state_list.addAll(get_ancestor());
		base_state_list.add(this);
		
		for(int j = 0; j < base_state_list.size(); j ++){
			list.addAll(base_state_list.get(j).get_valiable_list_local());
		}
		
		return list;
	}
	
	protected ArrayList<Model_Base_State> get_ancestor(){
		ArrayList<Model_Base_State> state_list = new ArrayList<Model_Base_State>();
		
		Model_Base_State s = this;
		
		while(s != null){
			Model_Base_State parent = s.get_parent();
			if(parent != null) state_list.add(parent);
			s = parent;
		}
		
		return state_list;
	}
	
	protected Model_Base_State get_parent(){
		if(is_root_state()) return null;
		
		Model_Base_State s;
		for(int j = 0; j < root.get_base_state_list().size(); j ++){
			s = root.get_base_state_list().get(j);
			if(s.get_state_name().equals(usr_extends)) return s;
		}
		
		return null;
	}
	
	protected ArrayList<String> get_valiable_list_local(){
		ArrayList<String> list = null;
		
		list = new ArrayList<String>();			
		
		String text = field_usr.replaceAll("\\n", ",\n");
		text = get_plain_text(text);
		
		//}以降削除
		text = text.replaceAll("}.*", "");
		
		String[] list2 = text.split(",");
		
		for (int i = 0; i < list2.length; i ++){
			//list.add(list2[i].replaceAll(":.*", ""));
			if(list2[i].matches("\\S+:\\S+")) list.add("[" + state_name + "] " + list2[i]);
		}
	
		return list;
	}
	
	protected String get_plain_text(String text){
		//コメント削除(// ~ 改行)
		String ret = text.replaceAll("//.*\\n", "");
		
		//コメント削除(// ~ 最後尾)
		ret = ret.replaceAll("//.*", "");
		
		//空白削除
		ret = ret.replaceAll("\\s", "");
		
		//空白削除
		ret = ret.replaceAll("　", "");
		
		//タブ削除
		ret = ret.replaceAll("\\t", "");
		
		//改行削除
		ret = ret.replaceAll("\\n", "");
		
		//コメント削除(/* ~ */)
		ret = ret.replaceAll("/\\*/?([^/]|[^*]/)*\\*/", "");
		
		return ret;
	}
	
	public String get_state_name(){
		return state_name;
	}
	
	public String get_extends(){
		return usr_extends;
	}
	
	public String get_field_usr(){
		return field_usr;
	}
	
	public boolean is_root_state(){
		return is_root_state;
	}
	
	public String get_field_default(){
		String text = "";
		text += "sig " + get_state_name();
		if(is_root_state() == false) text += " extends ";
		return text;
	}

	@Override
	public String get_alloy() {
		String alloy = "";
		
		alloy += "/*\n" + insert_tab("状態:" + get_state_name()) + "\n*/\n";
		alloy += get_field_default() + get_extends() + " {\n";
		alloy += get_field_usr() + "\n";
		alloy += "pred show_" + get_state_name() + "{}\n";
		alloy += "run show_" + get_state_name() + " for 3 but exactly 1 " + get_state_name() + "\n\n";
			
		return alloy;
	}

	@Override
	public String get_xml() {
		String text = "";
		
		text += "\t\t<Base_State>\n";
		text += "\t\t\t<is_root_state><![CDATA[" + is_root_state + "]]></is_root_state>\n";
		text += "\t\t\t<label><![CDATA[" + label + "]]></label>\n";
		text += "\t\t\t<state_name><![CDATA[" + state_name + "]]></state_name>\n";
		text += "\t\t\t<usr_extends><![CDATA[" + usr_extends + "]]></usr_extends>\n";
		text += "\t\t\t<field_usr><![CDATA[" + field_usr + "]]></field_usr>\n";
		text += "\t\t</Base_State>\n";
		
		return text;
	}

	@Override
	public void set_xml(Element xml) {
		if(is_exist_xml_tag(xml, "is_root_state")){
			if(get_xml_string(xml, "is_root_state").equals("true")) is_root_state = true;
			else is_root_state = false;
		}
		if(is_exist_xml_tag(xml, "label")) label = get_xml_string(xml, "label");
		if(is_exist_xml_tag(xml, "state_name")) state_name = get_xml_string(xml, "state_name");
		if(is_exist_xml_tag(xml, "field_usr")) field_usr = get_xml_string(xml, "field_usr");
		if(is_exist_xml_tag(xml, "usr_extends")) usr_extends = get_xml_string(xml, "usr_extends");
	}
}
