import java.awt.Point;
import java.util.ArrayList;

import org.w3c.dom.Element;


abstract public class Model_Canvas_Elem extends Model_Elem {
	transient protected float scale = 1.0f;
	
	Model_Canvas_Elem(Model_Root _root){
		super(_root);

		scale = 1.0f;
	}
	
	Model_Canvas_Elem(Model_Root _root, Element xml){
		super(_root);

		scale = 1.0f;		
		set_xml(xml);
	}
	
	public void set_scale(float s){
		scale = s;
	}
	
	protected float scale(){
		return scale;
	}
	
	protected int scaled(int x){
		return (int)(x * scale());
	}
	
	protected Point scaled_p(Point _p){
		return new Point(scaled(_p.x), scaled(_p.y));
	}
	
	protected int unscaled(int x){
		return (int)(x / scale());
	}
	
	protected Point unscaled_p(Point _p){
		return new Point(unscaled(_p.x), unscaled(_p.y));
	}
	
	protected ArrayList<Point> scaled_p_list(ArrayList<Point> _list){
		ArrayList<Point> list = new ArrayList<Point>();
		
		for(int i = 0; i < _list.size(); i ++){
			list.add(scaled_p(_list.get(i)));
		}
		return list;
	}
}
