import java.util.ArrayList;

import org.w3c.dom.Element;


public class Model_Event extends Model_Elem {
	protected String name = "event";
	protected String param = "";
	
	
	Model_Event(Model_Root _root, String _name, String _param){
		super(_root);
		
		name = _name;
		param = _param;
	}
	
	Model_Event(Model_Root _root, Element xml){
		super(_root);
		
		set_xml(xml);
	}

	public void set_name(String _name){
		name = _name;
	}
	
	public void set_param(String _param){
		param = _param;
	}
	
	public String get_param(){
		return param;
	}
	
	public String get_name(){
		return name;
	}
	
	public String get_full_name(){
		if(param.isEmpty()) return name;
		else return name + " (" + param + ")";
	}
	
	public String get_param_names(){
		String text = "";
		
		String[] list = param.split(",");
		for(int i = 0; i < list.length; i ++){
			list[i] = list[i].replaceAll(":.*", "");
			list[i] = list[i].replaceAll(" ", "");
			if(list[i] != ""){
				text += ", " + list[i];
			}
		}
		
		return text;
	}
	
	public String get_alloy_param_def(){
		String alloy = "";
		
		alloy += " (disj s, s' : " + root.get_root_state().get_state_name();
		if(get_param().equals("") == false){
			alloy += ", ";
		}
		alloy += get_param() + ") {\n";
		
		return alloy;
	}
	
	@Override
	public String get_alloy() {
		String alloy = "";
		
		alloy += "/*\n" + insert_tab("イベント:" + get_full_name()) + "\n*/\n";

		alloy += "pred " + name + get_alloy_param_def();
		
		ArrayList<Model_Trans> trans_list = new ArrayList<Model_Trans>();
		for(int i = 0; i < root.get_trans_list().size(); i ++){
			if(root.get_trans_list().get(i).get_event() == this){
				trans_list.add(root.get_trans_list().get(i));
			}
		}
		
		for(int i = 0; i < trans_list.size(); i ++){
			alloy += "\t" + trans_list.get(i).get_pred_full_name() + " [s, s'" + get_param_names() + "]";
			
			if(i < trans_list.size() - 1){
				alloy += " ||\n";
			}
			else{
				alloy += "\n";
			}
		}
		
		alloy += "}\n";
		alloy += "run " + name + " for 3 but exactly 2 " + root.get_root_state().get_state_name() + "\n\n";
		
		return alloy;
	}

	@Override
	public String get_xml() {
		String text = "";
		
		text += "\t\t<Event>\n";	
		text += "\t\t\t<name><![CDATA[" + name + "]]></name>\n";
		text += "\t\t\t<param><![CDATA[" + param + "]]></param>\n";	
		text += "\t\t</Event>\n";
		
		return text;
	}

	@Override
	public void set_xml(Element xml) {
		if(is_exist_xml_tag(xml, "name")) name = get_xml_string(xml, "name");
		if(is_exist_xml_tag(xml, "param")) param = get_xml_string(xml, "param");
	}
}
