import org.w3c.dom.Element;


public class Model_Global_Def extends Model_Elem {
	protected String def_usr = "";
	protected String trace_usr = "";
	
	
	Model_Global_Def(Model_Root _root){
		super(_root);
		
		def_usr = get_default_def();
		trace_usr = "";
	}
	
	Model_Global_Def(Model_Root _root, Element xml){
		super(_root);
		
		set_xml(xml);
	}
	
	public void set_def_usr(String text){
		def_usr = text;
	}
	
	public void set_trace_usr(String text){
		trace_usr = text;
	}
	
	public String get_default_def(){
		String text = "";
		
		text += "open util/ordering[" + Model_Base_State.ROOT_STATE_NAME + "] as " + Model_Base_State.ROOT_STATE_NAME + "Ord\n";
		text += "open util/relation\n";
		
		return text;
	}
	
	public String get_def_usr(){
		return def_usr;
	}
		
	public String get_trace_default(){
		String text = "";
		
		text += "/*\n\ttrace\n*/\n";
		text += "pred trace(goal_s : " + Model_Base_State.ROOT_STATE_NAME + "){\n";
		text += "\tall s : " + Model_Base_State.ROOT_STATE_NAME + "Ord/prevs[goal_s] | {\n";
		text += "\t\tlet s' = " + Model_Base_State.ROOT_STATE_NAME + "Ord/next[s] | {\n";
		text += root.get_trace_pred_text() + "\n";
		text += "\t\t}\n";
		text += "\t}\n";
		text += "}\n";
		text += "run trace for 3 but 8 State\n\n";
		text += "pred trace_test(init, goal : State){\n";
		text += "\tinit = StateOrd/first[]\n";
		text += "\ttrace[goal]\n";
		text += "}\n";
		text += "run trace_test for 3 but 8 State\n";
		
		return text;
	}
	
	public String get_trace_usr(){
		return trace_usr;
	}

	@Override
	public String get_alloy() {
		String alloy = "";
		
		alloy += get_def_usr() + "\n";
		alloy += get_trace_default() + "\n";
		alloy += get_trace_usr() + "\n\n";
	
		return alloy;
	}

	@Override
	public String get_xml() {
		String text = "";
		
		text += "\t<Global_Definition>\n";
		text += "\t\t<def_usr><![CDATA[" + def_usr + "]]></def_usr>\n";
		text += "\t\t<trace_usr><![CDATA[" + trace_usr + "]]></trace_usr>\n";
		text += "\t</Global_Definition>\n";
		
		return text;
	}

	@Override
	public void set_xml(Element xml) {
		if(is_exist_xml_tag(xml, "def_usr")) def_usr = get_xml_string(xml, "def_usr");
		if(is_exist_xml_tag(xml, "trace_usr")) trace_usr = get_xml_string(xml, "trace_usr");    
	}
}
