import java.awt.Point;

import org.w3c.dom.Element;


public class Model_Memo extends Model_Canvas_Elem {
	protected String memo = "";
	protected Point pos = new Point(0, 0);		//左上座標
	
	Model_Memo(Model_Root _root, Point _pos, String _memo){
		super(_root);
		
		pos = _pos;
		memo = _memo;
	}
	
	Model_Memo(Model_Root _root, Element xml){
		super(_root);
		
		set_xml(xml);
	}
	
	//図形
	public void set_pos(Point p){
		pos = unscaled_p(p);
	}
	
	public void move_pos(int dx, int dy){
		pos.translate(unscaled(dx), unscaled(dy));	
	}
	
	public Point get_pos(){
		return scaled_p(pos);
	}
	
	//alloy
	public void set_memo(String text){
		memo = text;
	}
	
	public String get_memo(){
		return memo;
	}

	@Override
	public String get_alloy() {
		String alloy = "";
		
		alloy += "/*\tMemo\n";
		alloy += "\t" + memo.replaceAll("\n", "\n\t") + "\n";
		alloy += "*/\n\n";
		
		return alloy;
	}

	@Override
	public String get_xml() {
		String text = "";
		
		text += "\t\t<Memo>\n";	
		text += "\t\t\t<memo><![CDATA[" + memo + "]]></memo>\n";
		text += "\t\t\t<pos.x><![CDATA[" + pos.x + "]]></pos.x>\n";
		text += "\t\t\t<pos.y><![CDATA[" + pos.y + "]]></pos.y>\n";
		text += "\t\t</Memo>\n";
		
		return text;
	}

	@Override
	public void set_xml(Element xml) {
		if(is_exist_xml_tag(xml, "memo")) memo = get_xml_string(xml, "memo");
		if(is_exist_xml_tag(xml, "pos.x")) pos.x = Integer.valueOf(get_xml_string(xml, "pos.x"));
		if(is_exist_xml_tag(xml, "pos.y")) pos.y = Integer.valueOf(get_xml_string(xml, "pos.y"));
	}

}
